//=============================================================================
// IG_Brute.
//=============================================================================
class IG_Brute expands IG_Handler;

function ImplantFire()
{
	if ( (ImplantPawn.Physics != PHYS_Falling) && ((ImplantPawn.AnimSequence == 'Breath2') || (ImplantPawn.AnimSequence == 'Walk') || (ImplantPawn.AnimSequence == 'Charge') || (ImplantPawn.AnimSequence == 'Fighter')) )
	{
		bStay = True;

		if ( (Controller.bDuck > 0) && (ImplantPawn.Physics != PHYS_Swimming) && (VSize(ImplantPawn.Velocity) == 0) )
		{
			ImplantPawn.LoopAnim('CockGun',1.0,0.05);
			return;
		}

		FindTarget();

		if ( ImplantPawn.Target != None )
		{
			if ( FRand() < 0.6 )
			{
				ImplantPawn.LoopAnim('PistolWhip',1.0,0.05);

				GotoState('ImplantFiring','PistolWhip');
			}
			else
			{
				ImplantPawn.LoopAnim('Punch',1.0,0.05);

				GotoState('ImplantFiring','Punch');
			}

			return;
		}

		if ( ImplantPawn.Physics == PHYS_Swimming )
		{
			ImplantPawn.LoopAnim('StillFire',1.0,0.1);

			GotoState('ImplantFiring','StillFire');
		}
		else if ( (VSize(ImplantPawn.Velocity) > 0) && bWalk )
		{
			bStay = False;

			ImplantPawn.LoopAnim('WalkFire',1.0,0.05);
		}
		else
		{
			ImplantPawn.LoopAnim('StillFire',1.0,0.1);

			GotoState('ImplantFiring','StillFire');
		}
	}
}

state ImplantFiring
{
	function AnimCheck(name Anim)
	{
		if ( Anim != ImplantPawn.AnimSequence )
		return;

		FindTarget();

		if ( !b227 && (ImplantPawn.Target == None) )
		ImplantPawn.LoopAnim('Breath2',0.5,0.2);
		else if ( (ImplantPawn.Target == None) || (ImplantPawn.Target == Level) || (Mover(ImplantPawn.Target) != None) )
		WallTarget();
	}

	function WallTarget()
	{
		ImplantPawn.PlaySound(Brute(ImplantPawn).PistolWhip,SLOT_Interact);

		if ( (Mover(ImplantPawn.Target) != None) && Mover(ImplantPawn.Target).bDamageTriggered )
		ImplantPawn.Target.TakeDamage(Brute(ImplantPawn).WhipDamage,ImplantPawn,ImplantPawn.Target.Location,vect(0,0,0),'Hacked');
	}

PistolWhip:
	Sleep(0.34);
	AnimCheck('PistolWhip');
	Goto('End');

Punch:
	Sleep(0.46);
	AnimCheck('Punch');
	Goto('End');

StillFire:
	Sleep(0.1);
	if ( ImplantPawn.AnimSequence == 'StillFire' )
	Brute(ImplantPawn).SpawnRightShot();
	Goto('End');
}

function ImplantMovement()
{
	Super.ImplantMovement();

	if ( (ImplantPawn.Physics == PHYS_Walking) && !bStay && bMove && bWalk )
	ImplantPawn.Velocity *= 0.4;
}

function ImplantAnimation()
{
	if ( (ImplantPawn.Physics == PHYS_Walking) && (VSize(ImplantPawn.Velocity) > 0) && bWalk && (ImplantPawn.AnimSequence != 'Walk') && (ImplantPawn.AnimSequence != 'WalkFire') && !bStay )
	ImplantPawn.LoopAnim('Walk',1.0,0.1);
	else if ( (ImplantPawn.Physics == PHYS_Walking) && (VSize(ImplantPawn.Velocity) > 0) && !bWalk && (ImplantPawn.AnimSequence != 'Charge') && !bStay )
	ImplantPawn.LoopAnim('Charge',1.0,0.1);
	else if ( (ImplantPawn.Physics == PHYS_Swimming) && (ImplantPawn.AnimSequence != 'Fighter') && (ImplantPawn.AnimSequence != 'StillFire') && !bStay )
	ImplantPawn.PlayAnim('Fighter',1.0,0.1);
	else if ( (ImplantPawn.Physics == PHYS_Walking) && (VSize(ImplantPawn.Velocity) == 0) && (ImplantPawn.AnimSequence != 'Breath2') && (ImplantPawn.AnimSequence != 'StillFire') && (ImplantPawn.AnimSequence != 'PistolWhip') && (ImplantPawn.AnimSequence != 'Punch') && !bStay )
	ImplantPawn.LoopAnim('Breath2',0.5,0.1);

	if ( ((ImplantPawn.AnimSequence == 'Breath2') || (ImplantPawn.AnimSequence == 'Fighter') || (ImplantPawn.AnimSequence == 'StillLook')) && bStay )
	bStay = False;
}

function Initialize()
{
	Super.Initialize();

	ImplantPawn.GroundSpeed = 2.5*ImplantPawn.default.GroundSpeed;
}

function Destroyed()
{
	Super.Destroyed();

	if ( (ImplantPawn != None) && (ImplantPawn.Health > 0) && !ImplantPawn.bDeleteMe )
	ImplantPawn.GroundSpeed = ImplantPawn.default.GroundSpeed;
}

defaultproperties
{
}
