//=============================================================================
// IG_Dragon.
//=============================================================================
class IG_Dragon expands IG_Handler;

var sound WingSound, FlapSound, SneezeSound, ScreamSound, FireSound, BiteSound;
var byte BiteDamage;
var bool bQuiet;
var float ShotDelay, LandingCounter;

function ImplantFire()
{
	if ( (ImplantPawn.AnimSequence == 'Fly') || (ImplantPawn.AnimSequence == 'Walk') || (ImplantPawn.AnimSequence == 'Breath') )
	{
		if ( ImplantPawn.Physics == PHYS_Walking )
		{
			if ( Controller.bDuck > 0 )
			{
				bStay = True;

				ImplantPawn.LoopAnim('Gust',1.0,0.05);

				GotoState('ImplantFiring','Gust');

				return;
			}

			if ( Controller.bRun > 0 )
			{
				bStay = True;

				ImplantPawn.LoopAnim('Sneeze',1.0,0.05);

				GotoState('ImplantFiring','Sneeze');

				return;
			}

			FindTarget();

			if ( ImplantPawn.Target != None )
			{
				bStay = True;

				ImplantPawn.LoopAnim('Bite',1.0,0.05);

				GotoState('ImplantFiring','Bite');
			}
			else if ( VSize(ImplantPawn.Velocity) > 0 )
			{
				ImplantPawn.LoopAnim('WalkFire',1.0,0.05);

				GotoState('ImplantFiring','WalkFire');
			}
			else
			{
				bStay = True;

				ImplantPawn.LoopAnim('Fire',1.0,0.05);

				GotoState('ImplantFiring','Fire');
			}

		}
		else if ( ImplantPawn.Physics == PHYS_Flying )
		{

			ImplantPawn.LoopAnim('FlyFire',1.0,0.05);

			GotoState('ImplantFiring','FlyFire');
		}
	}
}

state ImplantFiring
{
	function AnimCheck(name Anim)
	{
		if ( Anim != ImplantPawn.AnimSequence )
		return;

		FindTarget();

		if ( !b227 && (ImplantPawn.Target == None) )
		ImplantPawn.LoopAnim('Fly',1.0,0.2);
		else if ( (ImplantPawn.Target == Level) || (Mover(ImplantPawn.Target) != None) )
		WallTarget();
		else if ( ImplantPawn.Target != None )
		ImplantPawn.MeleeDamageTarget(BiteDamage,BiteDamage*1000*Normal(ImplantPawn.Target.Location-ImplantPawn.Location));
	}

	function WallTarget()
	{
		if ( (Mover(ImplantPawn.Target) != None) && Mover(ImplantPawn.Target).bDamageTriggered )
		ImplantPawn.Target.TakeDamage(BiteDamage,ImplantPawn,ImplantPawn.Target.Location,vect(0,0,0),'Hacked');
	}

Bite:
	ImplantPawn.PlaySound(BiteSound,SLOT_Interact);
	Sleep(0.3);
	AnimCheck('Bite');
	Goto('End');

WalkFire:
	if ( ShotDelay == 0.05 )
	Sleep(0.45);
	else
	Sleep(0.65);
	if ( ImplantPawn.AnimSequence != 'WalkFire' )
	Goto('End');
	ImplantPawn.PlaySound(FireSound,SLOT_Talk);
	ImplantPawn.FireProjectile(vect(1,0,0.6),500);
	Sleep(ShotDelay);
	if ( ImplantPawn.AnimSequence != 'WalkFire' )
	Goto('End');
	ImplantPawn.FireProjectile(vect(1,0,0.6),500);
	Sleep(ShotDelay);
	if ( ImplantPawn.AnimSequence != 'WalkFire' )
	Goto('End');
	ImplantPawn.FireProjectile(vect(1,0,0.6),500);
	Sleep(ShotDelay);
	if ( ImplantPawn.AnimSequence != 'WalkFire' )
	Goto('End');
	ImplantPawn.FireProjectile(vect(1,0,0.6),500);
	Sleep(ShotDelay);
	if ( ImplantPawn.AnimSequence != 'WalkFire' )
	Goto('End');
	ImplantPawn.FireProjectile(vect(1,0,0.6),500);
	Goto('End');

Fire:
	if ( ShotDelay == 0.05 )
	Sleep(0.3);
	else
	Sleep(0.45);
	if ( ImplantPawn.AnimSequence != 'Fire' )
	Goto('End');
	ImplantPawn.PlaySound(FireSound,SLOT_Talk);
	ImplantPawn.FireProjectile(vect(1,0,0),500);
	Sleep(ShotDelay);
	if ( ImplantPawn.AnimSequence != 'Fire' )
	Goto('End');
	ImplantPawn.FireProjectile(vect(1,0,0),500);
	Sleep(ShotDelay);
	if ( ImplantPawn.AnimSequence != 'Fire' )
	Goto('End');
	ImplantPawn.FireProjectile(vect(1,0,0),500);
	Sleep(ShotDelay);
	if ( ImplantPawn.AnimSequence != 'Fire' )
	Goto('End');
	ImplantPawn.FireProjectile(vect(1,0,0),500);
	Sleep(ShotDelay);
	if ( ImplantPawn.AnimSequence != 'Fire' )
	Goto('End');
	ImplantPawn.FireProjectile(vect(1,0,0),500);
	Goto('End');

FlyFire:
	Sleep(0.5);
	if ( ImplantPawn.AnimSequence != 'FlyFire' )
	Goto('End');
	ImplantPawn.PlaySound(FireSound,SLOT_Talk);
	Sleep(ShotDelay);
	if ( ImplantPawn.AnimSequence != 'FlyFire' )
	Goto('End');
	ImplantPawn.FireProjectile(vect(0.8,0,0.8),500);
	Sleep(ShotDelay);
	if ( ImplantPawn.AnimSequence != 'FlyFire' )
	Goto('End');
	ImplantPawn.FireProjectile(vect(0.8,0,0.8),500);
	Sleep(ShotDelay);
	if ( ImplantPawn.AnimSequence != 'FlyFire' )
	Goto('End');
	ImplantPawn.FireProjectile(vect(0.8,0,0.8),500);
	Sleep(ShotDelay);
	if ( ImplantPawn.AnimSequence != 'FlyFire' )
	Goto('End');
	ImplantPawn.FireProjectile(vect(0.8,0,0.8),500);
	Sleep(ShotDelay);
	if ( ImplantPawn.AnimSequence != 'FlyFire' )
	Goto('End');
	ImplantPawn.FireProjectile(vect(0.8,0,0.8),500);
	Goto('End');

Gust:
	ImplantPawn.PlaySound(ScreamSound,SLOT_Talk);
	Sleep(0.3);
	if ( ImplantPawn.AnimSequence == 'Gust' )
	ImplantPawn.PlaySound(FlapSound,SLOT_Interact);
	Sleep(0.4);
	if ( ImplantPawn.AnimSequence == 'Gust' )
	ImplantPawn.PlaySound(FlapSound,SLOT_Interact);
	Sleep(0.4);
	if ( ImplantPawn.AnimSequence == 'Gust' )
	ImplantPawn.PlaySound(FlapSound,SLOT_Interact);
	Goto('End');

Sneeze:
	Sleep(0.86);
	if ( ImplantPawn.AnimSequence == 'Sneeze' )
	ImplantPawn.PlaySound(SneezeSound,SLOT_Interact);
	Goto('End');

TakeOff:
	Sleep(0.2);
	if ( ImplantPawn.AnimSequence == 'TakeOff' )
	ImplantPawn.PlaySound(WingSound,SLOT_Interact);
	Goto('End');
}

function ImplantJump()
{
	if ( bCanFly || bStay )
	return;

	bCanFly = True;

	bStay = True;

	ImplantPawn.PlayAnim('TakeOff',1.0,0.1);

	GotoState('ImplantFiring','TakeOff');
}

function HandlePawn(float DeltaTime)
{
	local Actor A;
	local vector Dummy;

	if ( ImplantPawn.Region.Zone.bWaterZone )
	{
		bCanFly = True;

		LandingCounter = 0;

		return;
	}

	if ( (Controller.bDuck > 0) && bCanFly )
	{
		A = Trace(Dummy,Dummy,ImplantPawn.Location-(ImplantPawn.CollisionHeight+ImplantPawn.CollisionRadius*1.1)*vect(0,0,1),ImplantPawn.Location,False);

		if ( (A == Level) || (Mover(A) != None) )
		LandingCounter += DeltaTime;
		else
		LandingCounter = 0;

		if ( LandingCounter > 1 )
		{
			LandingCounter = 0;

			bCanFly = False;

			bStay = True;

			ImplantPawn.PlayAnim('Land',1.0,0.1);

			return;
		}
	}
	else
		LandingCounter = 0;
}

function ImplantAnimation()
{
	if ( (ImplantPawn.Physics == PHYS_Walking) && (VSize(ImplantPawn.Velocity) > 0) && (ImplantPawn.AnimSequence != 'Walk') && (ImplantPawn.AnimSequence != 'WalkFire') && !bStay )
	ImplantPawn.LoopAnim('Walk',1.0,0.1);
	else if ( (ImplantPawn.Physics == PHYS_Walking) && (VSize(ImplantPawn.Velocity) == 0) && (ImplantPawn.AnimSequence != 'Breath') && (ImplantPawn.AnimSequence != 'Fire') && (ImplantPawn.AnimSequence != 'Bite') && (ImplantPawn.AnimSequence != 'Gust') && (ImplantPawn.AnimSequence != 'Sneeze') && ((ImplantPawn.AnimSequence != 'Land') || !bStay) )
	ImplantPawn.LoopAnim('Breath',0.5,0.1);
	else if ( (ImplantPawn.Physics == PHYS_Flying) && (ImplantPawn.AnimSequence != 'Fly') && (ImplantPawn.AnimSequence != 'FlyFire') && (ImplantPawn.AnimSequence != 'TakeOff') )
	ImplantPawn.LoopAnim('Fly',1.0,0.1);

	if ( ((ImplantPawn.AnimSequence == 'Breath') || (ImplantPawn.AnimSequence == 'Fly')) && bStay )
	bStay = False;
}

function Initialize()
{
	Super.Initialize();

	bQuiet = ImplantPawn.bQuiet;

	ImplantPawn.bQuiet = True;

	WingSound = Sound(DynamicLoadObject("UPSXDragon.DragonWings",class'Sound'));

	FlapSound = Sound(DynamicLoadObject("UPSXDragon.DragonFlap2",class'Sound'));

	SneezeSound = Sound(DynamicLoadObject("UPSXDragon.DragonWander",class'Sound'));

	ScreamSound = Sound(DynamicLoadObject("UPSXDragon.Dragonsight2",class'Sound'));

	FireSound = Sound(DynamicLoadObject("UPSXDragon.DragonAttack",class'Sound'));

	BiteSound = Sound(DynamicLoadObject("UPSXDragon.DragonPain3",class'Sound'));

	BiteDamage = 40;

	bCanFly = ImplantPawn.Physics == PHYS_Flying;

	if ( Caps(String(ImplantPawn.Class)) == "UPSXDRAGON.FANG" )
	ShotDelay = 0.01;
	else
	ShotDelay = 0.05;
}

function Destroyed()
{
	Super.Destroyed();

	if ( (ImplantPawn != None) && (ImplantPawn.Health > 0) && !ImplantPawn.bDeleteMe )
	ImplantPawn.bQuiet = bQuiet;
}

defaultproperties
{
     bCanJump=True
     bCanWalk=False
}
