//=============================================================================
// IG_Drop.
//=============================================================================
class IG_Drop expands Effects;

function PostBeginPlay()
{
	LifeSpan = 2+FRand();

	DrawScale = 0.3+FRand()*0.2;

	Velocity = 200*VRand()*FRand()+150*Vector(Rotation);
}

function ZoneChange(ZoneInfo NewZone)
{
	if ( NewZone.bWaterZone )
	Destroy();
}

function HitWall(vector HitNormal, Actor Wall)
{
	Destroy();
}

function Landed(vector HitNormal)
{
	Destroy();
}

function Tick(float DeltaTime)
{
	local rotator NewRot;

	NewRot = Rotator(Velocity);

	NewRot.Pitch += 16384;

	SetRotation(NewRot);

	if ( LifeSpan > 1 )
	return;

	ScaleGlow = default.ScaleGlow*LifeSpan;

	AmbientGlow = default.AmbientGlow*LifeSpan;
}

simulated function PreBeginPlay()
{
	Super.PreBeginPlay();

	if ( (Int(Level.EngineVersion) < 226) && (Level.NetMode != NM_DedicatedServer) )
	MultiSkins[0] = Texture'UDamageFX';
}

defaultproperties
{
     DrawType=DT_Mesh
     Mesh=Mesh'dripMesh'
     Style=STY_Translucent
     bUnlit=True
     AmbientGlow=64
     Skin=Texture'Damagewet'
     bCollideWorld=True
     Physics=PHYS_Falling
     RemoteRole=ROLE_None
}
