//=============================================================================
// IG_Handler.
//=============================================================================
class IG_Handler expands Actor;

var ScriptedPawn ImplantPawn;
var PlayerPawn Controller;
var IG_Beacon Beacon;

var bool bCanJump, bCanDodge, bCanWalk, bCanSwim, bCanFly, bAdjustSpeed, bWasForward, bWasBack, bWasLeft, bWasRight, bOldWasForward, bOldWasBack, bOldWasLeft, bOldWasRight, bMove, bWalk, bDodge, bStay, bSaveLoc, bInit, b227, bKeepTarget, bWaterJump, bKillOnRelease;
var vector FireOffset, OldVel, OldLoc;
var rotator StartRotation;
var float Duration, LastJump, LastDodge, LastForward, LastBack, LastLeft, LastRight, LastEnemy, WaterJumpZ, BackupDrawScale;
var int MoveDir, OldMoveDir;
var name IgnoreState, ImplantEvent, ReleaseEvent;
var string PawnName;

var ImplantGun Gun;

var IG_FootstepHandler FootstepHandler;

var mesh BackupMesh;

var float Counter;

replication
{
	reliable if ( Role == ROLE_Authority )
		Controller, ClientSetLocation, ClientDestroyed;

	reliable if ( (Role == ROLE_Authority) && bNetOwner )
		ImplantPawn, PawnName;

	reliable if ( (Role == ROLE_Authority) && bNetOwner && bNetInitial )
		Duration;

	reliable if ( Role < ROLE_Authority )
		UpdateMoveInput, UpdateMoveDirection;
}

function ImplantFire();

state ImplantFiring
{
	function SpawnProjectile()
	{
		local vector SpawnLoc, X, Y, Z;
		local float Scale;

		GetAxes(ImplantPawn.Rotation,X,Y,Z);

		Scale = ImplantPawn.CollisionHeight/ImplantPawn.default.CollisionHeight;

		SpawnLoc = ImplantPawn.Location+FireOffset.X*X*Scale+FireOffset.Y*Y*Scale+FireOffset.Z*Z*Scale;

		ImplantPawn.Spawn(ImplantPawn.RangedProjectile,,,SpawnLoc);
	}

End:
	bKeepTarget = False;
	GotoState('');
}

function HandlePawn(float DeltaTime);

function PlayJump();

function PlayDodge(string Dir)
{
	if ( Dir ~= "FORWARD" )
	{

	}
	else if ( Dir ~= "BACK" )
	{

	}
	else if ( Dir ~= "LEFT" )
	{

	}
	else if ( Dir ~= "RIGHT" )
	{

	}
}

simulated function Tick(float DeltaTime)
{
	Duration -= DeltaTime;

	if ( Level.NetMode == NM_Client )
	{
		ClientTick();
		return;
	}

	if ( (Duration < 0) || (ImplantPawn == None) || (ImplantPawn.Health < 1) || ImplantPawn.bDeleteMe || (Controller == None) || (Controller.Health < 1) || Controller.bDeleteMe || Controller.IsInState('CheatFlying') || (Gun == None) || Gun.bDeleteMe || (Gun.Owner != Controller) )
	{
		Destroy();
		return;
	}

	if ( !bInit )
	Initialize();

	ImplantMovement();

	ImplantAnimation();

	HandleController();

	HandlePawn(DeltaTime);

	HandleEnemy();


//	Used for debugging:

	Counter += DeltaTime;

	if ( Counter < 1 )
	return;

	Counter = 0;

//	BroadcastMessage(GetStateName());
}

function ImplantMovement()
{
	local vector Vel, tmpVect;
	local rotator tmpRot;

	tmpRot = Controller.Rotation;

	tmpRot.Roll = 0;

	ImplantPawn.SetRotation(tmpRot);

	if ( Level.NetMode != NM_DedicatedServer )
	GetControllerInput();

	bMove = bWasForward || bWasBack || bWasLeft || bWasRight;

	bWalk = bCanWalk && Controller.bRun > 0;

	bDodge = False;

	if ( !ImplantPawn.IsInState('Waiting') && !ImplantPawn.IsInState('TakeHit') && !ImplantPawn.IsInState(IgnoreState) && (ImplantPawn.Physics != PHYS_Falling) )
	ImplantPawn.GotoState('Waiting');

	if ( ((ImplantPawn.Physics == PHYS_None) || (ImplantPawn.Physics == PHYS_Flying)) && !bCanFly )
	ImplantPawn.SetPhysics(PHYS_Walking);
	else if ( (ImplantPawn.Physics != PHYS_Flying) && bCanFly )
	ImplantPawn.SetPhysics(PHYS_Flying);
	else if ( ImplantPawn.Region.Zone.bWaterZone && bCanSwim && !bCanFly && (ImplantPawn.Physics != PHYS_Swimming) )
	ImplantPawn.SetPhysics(PHYS_Swimming);

	if ( bAdjustSpeed )
	ImplantPawn.DesiredSpeed = ImplantPawn.MaxDesiredSpeed;

	if ( ImplantPawn.bCanWalk && (Level.TimeSeconds-LastJump > 0.1) )
	ImplantPawn.bCanWalk = False;

	if ( ImplantPawn.Region.Zone.bWaterZone && (VSize(ImplantPawn.Acceleration) > 0) && (ImplantPawn.Velocity.Z < 0) )
	ImplantPawn.Acceleration = vect(0,0,0);

	if ( (ImplantPawn.Physics == PHYS_Swimming) && !bStay )
	{
		if ( bMove )
		{
			Vel = GetMoveDirection()*ImplantPawn.WaterSpeed;

			tmpRot.Yaw = 0;

			tmpVect = Vector(tmpRot);

			if ( bWasForward || bWasBack )
			Vel.Z = Sqrt(Square(VSize(tmpVect))-Square(tmpVect.X))*ImplantPawn.WaterSpeed*3.45;

			if ( tmpVect.Z < 0 )
			Vel.Z *= -1;

			if ( bWasBack )
			Vel.Z *= -1;
		}

		if ( Controller.bDuck > 0 )
		{
			if ( Controller.bRun > 0 )
			Vel.Z = ImplantPawn.WaterSpeed;
			else
			Vel.Z = -1*ImplantPawn.WaterSpeed;
		}
	}
	else if ( (ImplantPawn.Physics == PHYS_Flying) && !bStay )
	{
		if ( bMove )
		{
			Vel = GetMoveDirection()*ImplantPawn.AirSpeed;

			tmpRot.Yaw = 0;

			tmpVect = Vector(tmpRot);

			if ( bWasForward || bWasBack )
			Vel.Z = Sqrt(Square(VSize(tmpVect))-Square(tmpVect.X))*ImplantPawn.AirSpeed*3.45;

			if ( tmpVect.Z < 0 )
			Vel.Z *= -1;

			if ( bWasBack )
			Vel.Z *= -1;
		}

		if ( Controller.bDuck > 0 )
		{
			if ( Controller.bRun > 0 )
			Vel.Z = ImplantPawn.AirSpeed;
			else
			Vel.Z = -1*ImplantPawn.AirSpeed;
		}
	}
	else if ( (ImplantPawn.Physics == PHYS_Walking) && !bStay && bMove )
	{
		if ( !HandleDodge() )
		{
			Vel = GetMoveDirection()*ImplantPawn.GroundSpeed;

			tmpRot.Pitch = 0;

			if ( bCanJump && !bWalk && (VSize(Controller.Velocity) > 0) && (VSize(Vel) == VSize(OldVel)) && !bSaveLoc && (ImplantPawn.Location == OldLoc) && (ImplantPawn.TraceShot(tmpVect,tmpVect,ImplantPawn.Location+(ImplantPawn.CollisionRadius+64)*Vector(tmpRot),ImplantPawn.Location) == None) )
			{
				ImplantJump();

				Vel *= 0.5;

				Vel.Z = ImplantPawn.Velocity.Z;

				if ( ShortJump() )
				Vel *= 0.5;
			}
			else if ( bWalk )
				Vel *= ImplantPawn.WalkingSpeed;
		}
	}
	else if ( ImplantPawn.Physics == PHYS_Falling )
		Vel = ImplantPawn.Velocity;

	if ( !bDodge )
	ImplantPawn.Velocity = Vel;

	OldVel = Vel;

	bSaveLoc = !bSaveLoc;

	if ( bSaveLoc )
	OldLoc = ImplantPawn.Location;

	SetLastInput();

	AdjustWaterJump();
}

function vector GetMoveDirection()
{
	local rotator tmpRot;

	if ( Level.NetMode != NM_DedicatedServer )
	return Normal(Controller.Velocity);

	if ( MoveDir == 77777 )
	return vect(0,0,0);

	tmpRot.Yaw = MoveDir;

	return Vector(tmpRot);
}

function ImplantAnimation();

function HandleController()
{
	Controller.SetPhysics(PHYS_Walking);

	Controller.SetLocation(Location);

	Controller.Velocity = vect(0,0,0);

	Controller.DrawScale = 0;

	if ( Level.NetMode != NM_DedicatedServer )
	Controller.ViewRotation.Pitch = ImplantPawn.Rotation.Pitch;

	if ( Controller.ViewTarget == None )
	Controller.ViewTarget = ImplantPawn;

	if ( (Controller.Weapon != Gun) && !Controller.IsInState('FeigningDeath') )
	Controller.GetWeapon(Gun.Class);

	if ( !Controller.bCountJumps )
	Controller.bCountJumps = True;
}

function HandleEnemy()
{
	if ( Level.TimeSeconds-LastEnemy < 0.1 )
	return;

	ImplantPawn.Enemy = None;

	if ( !bKeepTarget )
	ImplantPawn.Target = None;
}

simulated function ClientTick()
{
	local rotator tmpRot;

	if ( Controller == None )
	return;

	Controller.SetLocation(Location);

	if ( !bNetOwner )
	return;

	if ( ImplantPawn != None )
	{
		tmpRot = Controller.Rotation;

		tmpRot.Roll = 0;

		ImplantPawn.SetRotation(tmpRot);
	}

	if ( (Controller.ViewRotation.Pitch > 3072) && (Controller.ViewRotation.Pitch < 32768) )
	Controller.ViewRotation.Pitch = 3072;
	else if ( (Controller.ViewRotation.Pitch < 62464) && (Controller.ViewRotation.Pitch > 3072) )
	Controller.ViewRotation.Pitch = 62464;

	GetControllerInput();

	if ( (bWasForward != bOldWasForward) || (bWasBack != bOldWasBack) || (bWasLeft != bOldWasLeft) || (bWasRight != bOldWasRight) )
	UpdateMoveInput(bWasForward,bWasBack,bWasLeft,bWasRight);

	SetLastInput();

	if ( VSize(Controller.Velocity) == 0 )
	{
		MoveDir = 77777;

		if ( MoveDir != OldMoveDir )
		UpdateMoveDirection(MoveDir);

		OldMoveDir = MoveDir;

		return;
	}

	tmpRot = Rotator(Controller.Velocity);

	MoveDir = tmpRot.Yaw;

	if ( MoveDir != OldMoveDir )
	UpdateMoveDirection(MoveDir);

	OldMoveDir = MoveDir;
}

simulated function GetControllerInput()
{
	bWasForward = Controller.bWasForward;

	bWasBack = Controller.bWasBack;

	bWasLeft = Controller.bWasLeft;

	bWasRight = Controller.bWasRight;
}

function UpdateMoveInput(bool bNewWasForward, bool bNewWasBack, bool bNewWasLeft, bool bNewWasRight)
{
	bWasForward = bNewWasForward;

	bWasBack = bNewWasBack;

	bWasLeft = bNewWasLeft;

	bWasRight = bNewWasRight;
}

function UpdateMoveDirection(int NewMoveDir)
{
	MoveDir = NewMoveDir;
}

simulated function SetLastInput()
{
	bOldWasForward = bWasForward;

	bOldWasBack = bWasBack;

	bOldWasLeft = bWasLeft;

	bOldWasRight = bWasRight;
}

function Initialize()
{
	bInit = True;

	RepositionSelf();

	bCollideWorld = True;

	SetDummy();

	SpawnBeacon();

	SetPawnName();

	ImplantPawn.Disable('SeePlayer');
	ImplantPawn.Disable('HearNoise');
	ImplantPawn.Disable('Bump');
	ImplantPawn.Disable('Trigger');
	ImplantPawn.SightRadius = 0;
	ImplantPawn.HearingThreshold = 10;
	ImplantPawn.RemoteRole = ROLE_DumbProxy;
	ImplantPawn.DesiredSpeed = ImplantPawn.MaxDesiredSpeed;
	ImplantPawn.bCanWalk = False;
	ImplantPawn.bCanFly = False;
	ImplantPawn.Acquire = None;
	ImplantPawn.Roam = None;
	ImplantPawn.Threaten = None;

	if ( ImplantPawn.Physics != PHYS_Falling )
	ImplantPawn.GotoState('Waiting');

	StartRotation.Yaw = Controller.Rotation.Yaw;

	BackupDrawScale = Controller.DrawScale;

	Controller.DrawScale = 0;
	Controller.SetCollision(False,False,False);
	Controller.SetCollisionSize(1,Controller.CollisionHeight);
	Controller.Mass = 1000;
	Controller.ClientFlash(1,vect(1000,500,1000));
	Controller.ClientSetRotation(ImplantPawn.Rotation);
	Controller.JumpSound = None;

	FootstepHandler = Spawn(class'IG_FootstepHandler',Owner,,Owner.Location);

	if ( Controller.Mesh == Mesh'Male1' )
	{
		BackupMesh = Controller.Mesh;

		Controller.Mesh = Mesh'Male2';
	}

	b227 = Int(Level.EngineVersion) >= 227;

	Spawn(class'IG_Activation',ImplantPawn,,ImplantPawn.Location);

	TriggerImplantEvent();
}

function RepositionSelf()
{
	local vector HitLocation, HitNormal;

	if ( (Controller.Physics != PHYS_Falling) || (Controller.TraceShot(HitLocation,HitNormal,Location-vect(0,0,256),Location) != Level) )
	return;

	Controller.SetPhysics(PHYS_Walking);

	SetLocation(HitLocation+vect(0,0,1)*Controller.CollisionHeight);

	if ( Level.NetMode == NM_DedicatedServer )
	ClientSetLocation(Location);
}

simulated function ClientSetLocation(vector NewLoc)
{
	SetLocation(NewLoc);
}

function SetDummy()
{
	local int i;

	SetCollisionSize(Controller.CollisionRadius,Controller.CollisionHeight);

	AmbientGlow = Controller.AmbientGlow;

	bMeshEnviroMap = Controller.bMeshEnviroMap;

	bNoSmooth = Controller.bNoSmooth;

	bUnlit = Controller.bUnlit;

	DrawScale = Controller.DrawScale;

	DrawType = Controller.DrawType;

	Fatness = Controller.Fatness;

	Mesh = Controller.Mesh;

	for ( i = 0; i < 8; i++ )
	MultiSkins[i] = Controller.MultiSkins[i];

	PrePivot = Controller.PrePivot;

	ScaleGlow = Controller.ScaleGlow;

	Skin = Controller.Skin;

	Style = Controller.Style;

	Texture = Controller.Texture;

	if ( HasAnim('Breath1') )
	LoopAnim('Breath1',0.6);
	else if ( Mesh == Mesh'sktrooper' )
	LoopAnim('Breath2',0.6);
	else if ( HasAnim('Breath') )
	LoopAnim('Breath',0.6);
}

function SpawnBeacon()
{
	if ( Level.NetMode != NM_DedicatedServer )
	return;

	Beacon = Spawn(class'IG_Beacon',Controller,,ImplantPawn.Location);

	if ( Beacon != None )
	Beacon.ImplantPawn = ImplantPawn;
}

function SetPawnName()
{
	if ( ImplantPawn.MenuName == "" )
	ImplantPawn.MenuName = String(ImplantPawn.Class.Name);

	PawnName = ImplantPawn.MenuName;
}

function TakeDamage(int Damage, Pawn InstigatedBy, vector HitLocation, vector Momentum, name DamageType)
{
	Controller.TakeDamage(Damage,InstigatedBy,HitLocation,vect(0,0,0),DamageType);
}

function KilledBy(Pawn EventInstigator)
{
	Controller.KilledBy(EventInstigator);
}

function ImplantJump()
{
	local vector WallNormal;

	if ( !bCanJump || bStay || (Level.TimeSeconds-LastJump < 0.5) || (ImplantPawn.Physics == PHYS_Falling) || ((ImplantPawn.Physics == PHYS_Swimming) && ImplantPawn.HeadRegion.Zone.bWaterZone) )
	return;

	LastJump = Level.TimeSeconds;

	if ( (ImplantPawn.Physics == PHYS_Swimming) && !ImplantPawn.HeadRegion.Zone.bWaterZone )
	{
		if ( !ImplantPawn.CheckWaterJump(WallNormal) )
		return;

		ImplantPawn.Acceleration = ImplantPawn.AccelRate*WallNormal;
		ImplantPawn.bCanWalk = True;
	}

	if ( !ImplantPawn.Region.Zone.bWaterZone || !OrderCheck() || (!bCanSwim && ImplantPawn.Region.Zone.bWaterZone) )
	ImplantPawn.SetPhysics(PHYS_Falling);

	ImplantPawn.Velocity.Z = ImplantPawn.JumpZ;
	ImplantPawn.GotoState('FallingState','PlayFall');

	PlayJump();
}

function AdjustWaterJump()
{
	if ( WaterJumpZ == 0 )
	return;

	if ( Abs(ImplantPawn.Acceleration.X)+Abs(ImplantPawn.Acceleration.Y) == 0 )
	{
		bWaterJump = False;

		return;
	}

	if ( bWaterJump || ImplantPawn.Region.Zone.bWaterZone || (ImplantPawn.Velocity.Z > 360) )
	return;

	bWaterJump = True;

	ImplantPawn.Velocity.Z = WaterJumpZ;
}

function bool OrderCheck()
{
	local Actor A;

	if ( Level.NetMode == NM_DedicatedServer )
	return True;

	ForEach AllActors( class'Actor', A )
	if ( GameInfo(A) != None )
	return True;
	else if ( A == ImplantPawn )
	return False;

	return False;
}

function bool HandleDodge()
{
	if ( !bCanDodge || bCanFly || (VSize(Controller.Velocity) == 0) || (Level.TimeSeconds-LastDodge < 1) )
	return False;

	if ( bWasForward && !bOldWasForward && (Level.TimeSeconds-LastForward < 0.25) )
	{
		ImplantDodge("FORWARD");
		return True;
	}

	if ( bWasBack && !bOldWasBack && (Level.TimeSeconds-LastBack < 0.25) )
	{
		ImplantDodge("BACK");
		return True;
	}

	if ( bWasLeft && !bOldWasLeft && (Level.TimeSeconds-LastLeft < 0.25) )
	{
		ImplantDodge("LEFT");
		return True;
	}

	if ( bWasRight && !bOldWasRight && (Level.TimeSeconds-LastRight < 0.25) )
	{
		ImplantDodge("RIGHT");
		return True;
	}

	if ( bWasForward )
	LastForward = Level.TimeSeconds;

	if ( bWasBack)
	LastBack = Level.TimeSeconds;

	if ( bWasLeft )
	LastLeft = Level.TimeSeconds;

	if ( bWasRight )
	LastRight = Level.TimeSeconds;

	return False;
}

function ImplantDodge(string Dir)
{
	local rotator DodgeRot;

	if ( Dir ~= "FORWARD" )
	DodgeRot.Yaw = ImplantPawn.Rotation.Yaw;
	else if ( Dir ~= "BACK" )
	DodgeRot.Yaw = ImplantPawn.Rotation.Yaw+32768;
	else if ( Dir ~= "LEFT" )
	DodgeRot.Yaw = ImplantPawn.Rotation.Yaw+16384;
	else if ( Dir ~= "RIGHT" )
	DodgeRot.Yaw = ImplantPawn.Rotation.Yaw-16384;

	LastDodge = Level.TimeSeconds;

	bDodge = True;

	ImplantPawn.bUpAndOut = True;
	ImplantPawn.SetPhysics(PHYS_Falling);
	ImplantPawn.Velocity += Vector(DodgeRot)*ImplantPawn.JumpZ*2+vect(0,0,1)*ImplantPawn.JumpZ/2;
	ImplantPawn.GotoState('FallingState','Ducking');

	PlayDodge(Dir);
}

function FindTarget()
{
	local vector X, Y, Z;
	local rotator tmpRot;

	tmpRot = Controller.Rotation;

	tmpRot.Roll = 0;

	ImplantPawn.SetRotation(tmpRot);

	GetAxes(ImplantPawn.Rotation,X,Y,Z);

	TraceActor(X,0.2);

	if ( ImplantPawn.Target == None )
	TraceActor(X,0.4);

	if ( ImplantPawn.Target == None )
	TraceActor(X,0.6);

	if ( ImplantPawn.Target == None )
	TraceActor(X,0.8);

	if ( ImplantPawn.Target == None )
	TraceActor(X,1.2);

	if ( ImplantPawn.Target == None )
	TraceActor(X,1.4);

	if ( ImplantPawn.Target == None )
	TraceActor(X,1.6);

	if ( ImplantPawn.Target == None )
	TraceActor(X,1.0,True);

	if ( ImplantPawn.Target == None )
	return;

	if ( IG_Handler(ImplantPawn.Target) != None )
	ImplantPawn.Target = ImplantPawn.Target.Owner;

	ImplantPawn.Enemy = Pawn(ImplantPawn.Target);

	if ( !b227 && (ImplantPawn.Enemy == None) )
	ImplantPawn.Target = None;
	else
	LastEnemy = Level.TimeSeconds;
}

function TraceActor(vector X, float Offset, optional bool bLevel)
{
	local vector TraceStart, TraceEnd, Dummy;

	TraceStart = ImplantPawn.Location+(Offset*ImplantPawn.CollisionHeight-ImplantPawn.CollisionHeight)*vect(0,0,1)+ImplantPawn.CollisionRadius*X;

	TraceEnd = TraceStart+ImplantPawn.MeleeRange*X;

	ImplantPawn.Target = ImplantPawn.TraceShot(Dummy,Dummy,TraceEnd,TraceStart);

	if ( (ImplantPawn.Target == Level) && !bLevel )
	ImplantPawn.Target = None;
}

function bool ShortJump()
{
	local SpecialEvent SE;

	ForEach AllActors( class'SpecialEvent', SE )
	if ( (String(SE.Tag) ~= "ShortJump") && (VSize(SE.Location-ImplantPawn.Location) < SE.CollisionRadius) )
	return True;

	return False;
}

function Destroyed()
{
	if ( (ImplantPawn != None) && (ImplantPawn.Health > 0) && !ImplantPawn.bDeleteMe )
	{
		if ( bKillOnRelease )
			ImplantPawn.Died(Controller,'Decapitated',ImplantPawn.Location);
		else
		{
			ImplantPawn.Enable('SeePlayer');
			ImplantPawn.Enable('HearNoise');
			ImplantPawn.Enable('Bump');
			ImplantPawn.Enable('Trigger');
			ImplantPawn.SightRadius = ImplantPawn.default.SightRadius;
			ImplantPawn.HearingThreshold = ImplantPawn.default.HearingThreshold;
			ImplantPawn.RemoteRole = ImplantPawn.default.RemoteRole;
			ImplantPawn.Acquire = ImplantPawn.default.Acquire;
			ImplantPawn.Roam = ImplantPawn.default.Roam;
			ImplantPawn.Threaten = ImplantPawn.default.Threaten;
			ImplantPawn.PreSetMovement();
			ImplantPawn.GotoState('Roaming');
		}
	}

	if ( (Controller != None) && !Controller.bDeleteMe )
	{
		if ( !Controller.IsInState('Dying') )
		Controller.SetCollision(True,True,True);
		else
		ModifyControllerCarcass();

		if ( BackupMesh != None )
		Controller.Mesh = BackupMesh;

		Controller.DrawScale = BackupDrawScale;
		Controller.SetCollisionSize(CollisionRadius,CollisionHeight);
		Controller.Mass = Controller.default.Mass;
		Controller.ClientFlash(1,vect(200,400,200));
		Controller.ClientSetRotation(StartRotation);
		Controller.ViewTarget = None;
		Controller.Velocity = vect(0,0,0);
		Controller.DodgeDir = DODGE_None;
		Controller.JumpSound = Controller.default.JumpSound;

		if ( FootstepHandler != None )
		FootstepHandler.Destroy();

		HandleJump();

		Spawn(class'IG_DeActivation',Controller,,Controller.Location);
	}

	if ( (Gun != None) && !Gun.bDeleteMe )
	{
		Gun.Handler = None;
		Gun.bCanThrow = True;
	}

	TriggerReleaseEvent();

	if ( Beacon != None )
	Beacon.Destroy();

	if ( Level.NetMode == NM_DedicatedServer )
	ClientDestroyed();
}

simulated function ClientDestroyed()
{
	if ( Controller != None )
	Controller.DodgeDir = DODGE_None;
}

function HandleJump()
{
	local JumpBoots Boots;

	Boots = JumpBoots(Controller.FindInventoryType(class'JumpBoots'));

	if ( Boots != None )
	Controller.bCountJumps = Boots.bActive;
	else
	Controller.bCountJumps = False;
}

function ModifyControllerCarcass()
{
	local CreatureCarcass CC;

	ForEach RadiusActors( class'CreatureCarcass', CC, 16, Controller.Location )
	if ( (CC.Class == Controller.CarcassType) && (CC.Instigator == Controller) )
	{
		if ( BackupMesh != None )
		CC.Mesh = BackupMesh;

		CC.DrawScale = BackupDrawScale;

		CC.SetRotation(StartRotation);
	}
}

function TriggerImplantEvent()
{
	local Actor A;

	if ( ImplantEvent != '' )
	ForEach AllActors( class'Actor', A )
	if ( A.Tag == ImplantEvent )
	A.Trigger(ImplantPawn,Controller);
}

function TriggerReleaseEvent()
{
	local Actor A;

	if ( ReleaseEvent != '' )
	ForEach AllActors( class'Actor', A )
	if ( A.Tag == ReleaseEvent )
	A.Trigger(ImplantPawn,Controller);
}

defaultproperties
{
     bCanJump=False
     bCanDodge=False
     bCanWalk=True
     bCanSwim=True
     bAdjustSpeed=True
     Duration=300.000000
     DrawType=DT_Mesh
     bCollideActors=True
     bBlockActors=True
     bBlockPlayers=True
     bProjTarget=True
     RemoteRole=ROLE_SimulatedProxy
}
