//=============================================================================
// IG_Krall.
//=============================================================================
class IG_Krall expands IG_Handler;

function ImplantFire()
{
	local float f;

	if ( (ImplantPawn.Physics != PHYS_Falling) && ((ImplantPawn.AnimSequence == 'Breath') || (ImplantPawn.AnimSequence == 'Walk') || (ImplantPawn.AnimSequence == 'Run') || (ImplantPawn.AnimSequence == 'Swim')) )
	{
		bStay = True;

		if ( (Controller.bDuck > 0) && (ImplantPawn.Physics != PHYS_Swimming) && (VSize(ImplantPawn.Velocity) == 0) )
		{
			ImplantPawn.LoopAnim('Twirl',0.6,0.05);

			ImplantPawn.PlaySound(Krall(ImplantPawn).Twirl,SLOT_Interact,0.5,,500);

			return;
		}

		FindTarget();

		if ( ImplantPawn.Target != None )
		{
			f = FRand();

			if ( f < 0.33 )
			{
				ImplantPawn.LoopAnim('Strike1',1.0,0.05);

				GotoState('ImplantFiring','Strike1');
			}
			else if ( f < 0.66 )
			{
				ImplantPawn.LoopAnim('Strike2',1.0,0.05);

				GotoState('ImplantFiring','Strike2');
			}
			else
			{
				ImplantPawn.LoopAnim('Strike3',1.0,0.05);

				GotoState('ImplantFiring','Strike3');
			}

			return;
		}

		if ( ImplantPawn.Physics == PHYS_Swimming )
		{
			ImplantPawn.LoopAnim('SwimFire',1.0,0.05);

			GotoState('ImplantFiring','SwimFire');
		}
		else if ( (VSize(ImplantPawn.Velocity) > 0) && bWalk )
		{
			bStay = False;

			ImplantPawn.LoopAnim('Shoot2',1.0,0.05);

			GotoState('ImplantFiring','WalkFire');
		}
		else
			ImplantPawn.LoopAnim('Shoot1',1.0,0.05);
	}
}

state ImplantFiring
{
	function AnimCheck(name Anim)
	{
		if ( Anim != ImplantPawn.AnimSequence )
		return;

		FindTarget();

		if ( !b227 && (ImplantPawn.Target == None) )
		ImplantPawn.LoopAnim('Breath',0.5,0.2);
		else if ( (ImplantPawn.Target == Level) || (Mover(ImplantPawn.Target) != None) )
		WallTarget();
	}

	function WallTarget()
	{
		ImplantPawn.PlaySound(Krall(ImplantPawn).SpearHit,SLOT_Interact);

		if ( (Mover(ImplantPawn.Target) != None) && Mover(ImplantPawn.Target).bDamageTriggered )
		ImplantPawn.Target.TakeDamage(Krall(ImplantPawn).StrikeDamage,ImplantPawn,ImplantPawn.Target.Location,vect(0,0,0),'Hacked');
	}

Strike1:
	Sleep(0.28);
	AnimCheck('Strike1');
	Goto('End');

Strike2:
	Sleep(0.4);
	AnimCheck('Strike2');
	Goto('End');

Strike3:
	Sleep(0.28);
	AnimCheck('Strike3');
	Goto('End');

SwimFire:
	Sleep(0.1);
	if ( ImplantPawn.AnimSequence == 'SwimFire' )
	Krall(ImplantPawn).SpawnShot();
	Goto('End');

WalkFire:
	Sleep(0.6);
	if ( ImplantPawn.AnimSequence == 'Shoot2' )
	bStay = True;
	Goto('End');
}

function PlayJump()
{
	ImplantPawn.PlaySound(Sound'syl2kr',SLOT_Talk);
}

function PlayDodge(string Dir)
{
	ImplantPawn.PlayAnim('Jump',1.0,1.0);

	ImplantPawn.PlaySound(Sound'syl2kr',SLOT_Talk);
}

function ImplantAnimation()
{
	if ( (ImplantPawn.Physics == PHYS_Walking) && (VSize(ImplantPawn.Velocity) > 0) && bWalk && (ImplantPawn.AnimSequence != 'Walk') && (ImplantPawn.AnimSequence != 'Shoot2') && !bStay )
	ImplantPawn.LoopAnim('Walk',1.0,0.1);
	else if ( (ImplantPawn.Physics == PHYS_Walking) && (VSize(ImplantPawn.Velocity) > 0) && !bWalk && (ImplantPawn.AnimSequence != 'Run') && !bStay )
	ImplantPawn.LoopAnim('Run',1.0,0.1);
	else if ( (ImplantPawn.Physics == PHYS_Swimming) && (ImplantPawn.AnimSequence != 'Swim') && (ImplantPawn.AnimSequence != 'SwimFire') && !bStay )
	ImplantPawn.LoopAnim('Swim',1.0,0.1);
	else if ( (ImplantPawn.Physics == PHYS_Walking) && (VSize(ImplantPawn.Velocity) == 0) && (ImplantPawn.AnimSequence != 'Breath') && (ImplantPawn.AnimSequence != 'Twirl') && (ImplantPawn.AnimSequence != 'Shoot1') && (ImplantPawn.AnimSequence != 'Shoot2') && (ImplantPawn.AnimSequence != 'Strike1') && (ImplantPawn.AnimSequence != 'Strike2') && (ImplantPawn.AnimSequence != 'Strike3') )
	ImplantPawn.LoopAnim('Breath',0.5,0.1);

	if ( ((ImplantPawn.AnimSequence == 'Breath') || (ImplantPawn.AnimSequence == 'Swim')) && bStay )
	bStay = False;
}

defaultproperties
{
     bCanJump=True
     bCanDodge=True
}
