//=============================================================================
// IG_Mercenary.
//=============================================================================
class IG_Mercenary expands IG_Handler;

var int SprayOffset;

function ImplantFire()
{
	if ( (ImplantPawn.Physics != PHYS_Falling) && ((ImplantPawn.AnimSequence == 'Breath') || (ImplantPawn.AnimSequence == 'Walk') || (ImplantPawn.AnimSequence == 'Run') || (ImplantPawn.AnimSequence == 'Swim')) )
	{
		bStay = True;

		if ( (Controller.bDuck > 0) && (ImplantPawn.Physics != PHYS_Swimming) && (VSize(ImplantPawn.Velocity) == 0) )
		{
			ImplantPawn.LoopAnim('Dance',1.0,0.05);

			return;
		}

		FindTarget();

		if ( ImplantPawn.Target != None )
		{
			if ( FRand() < 0.33 )
			{
				ImplantPawn.LoopAnim('Swat',1.0,0.05);

				ImplantPawn.PlaySound(Mercenary(ImplantPawn).Punch,SLOT_Interact);

				GotoState('ImplantFiring','Swat');
			}
			else
			{
				ImplantPawn.LoopAnim('Punch',1.0,0.05);

				ImplantPawn.PlaySound(Mercenary(ImplantPawn).Punch,SLOT_Interact);

				GotoState('ImplantFiring','Punch');
			}

			return;
		}

		if ( ImplantPawn.Physics == PHYS_Swimming )
		{
			bStay = False;

			ImplantPawn.LoopAnim('SwimFire',1.0,0.05);
		}
		else if ( VSize(ImplantPawn.Velocity) > 0 )
		{
			if ( bWalk )
			{
				bStay = False;

				ImplantPawn.LoopAnim('WalkFire',1.0,0.05);
			}
			else
			{
				ImplantPawn.LoopAnim('Spray',1.0,0.05);

				GotoState('ImplantFiring','Spray');
			}
		}
		else
		{
			if ( bWalk )
			{
				ImplantPawn.LoopAnim('Shoot',0.5,0.05);

				GotoState('ImplantFiring','Shoot');
			}
			else
			{
				ImplantPawn.LoopAnim('Spray',1.0,0.05);

				GotoState('ImplantFiring','Spray');
			}
		}
	}
}

state ImplantFiring
{
	function AnimCheck(name Anim)
	{
		if ( Anim != ImplantPawn.AnimSequence )
		return;

		FindTarget();

		if ( !b227 && (ImplantPawn.Target == None) )
		ImplantPawn.LoopAnim('Breath',0.5,0.2);
		else if ( (ImplantPawn.Target == Level) || (Mover(ImplantPawn.Target) != None) )
		WallTarget();
		else if ( ImplantPawn.Target != None )
		Mercenary(ImplantPawn).HitDamageTarget();
	}

	function WallTarget()
	{
		ImplantPawn.PlaySound(Mercenary(ImplantPawn).PunchHit,SLOT_Interact);

		if ( (Mover(ImplantPawn.Target) != None) && Mover(ImplantPawn.Target).bDamageTriggered )
		ImplantPawn.Target.TakeDamage(Mercenary(ImplantPawn).PunchDamage,ImplantPawn,ImplantPawn.Target.Location,vect(0,0,0),'Hacked');
	}

	function SprayTarget()
	{
		local vector HitLocation, HitNormal, TraceStart, TraceEnd, X, Y, Z;

		GetAxes(ImplantPawn.Rotation,X,Y,Z);

		TraceStart = ImplantPawn.Location;

		TraceEnd = TraceStart+2000*X;

		ImplantPawn.Target = ImplantPawn.TraceShot(HitLocation,HitNormal,TraceEnd,TraceStart);
	}

Swat:
	Sleep(0.4);
	AnimCheck('Swat');
	Goto('End');

Punch:
	Sleep(0.4);
	AnimCheck('Punch');
	Goto('End');

Shoot:
	Sleep(0.1);
	if ( ImplantPawn.AnimSequence == 'Shoot' )
	Mercenary(ImplantPawn).SpawnRocket();
	Goto('End');

Spray:
	SprayTarget();
	if ( ImplantPawn.Target == None )
	{
		ImplantPawn.LoopAnim('Shoot',0.5,0.05);
		Goto('Shoot');
	}
	Mercenary(ImplantPawn).SprayOffset = 0;
	SprayOffset = 0;
	bKeepTarget = True;
	Sleep(0.1);
	ImplantPawn.PlaySound(Mercenary(ImplantPawn).WeaponSpray,SLOT_Interact);

Repeat:
	Sleep(0.05);
	if ( ImplantPawn.AnimSequence != 'Spray' )
	Goto('End');
	if ( (Mercenary(ImplantPawn).SprayOffset > SprayOffset) || (SprayOffset == 0) )
	SprayTarget();
	else
	Goto('Repeat');
	SprayOffset = Mercenary(ImplantPawn).SprayOffset;
	if ( (ImplantPawn.Target != None) && (ImplantPawn.AnimSequence == 'Spray') )
	Goto('Repeat');
	Goto('End');
}

function PlayJump()
{
	ImplantPawn.PlaySound(Sound'syl3mr',SLOT_Talk);
}

function PlayDodge(string Dir)
{
	if ( Dir ~= "FORWARD" )
	ImplantPawn.PlayAnim('Jump',2.0,0.05);
	else
	ImplantPawn.PlayAnim('Jump2',1.0,1.0);

	ImplantPawn.PlaySound(Sound'syl3mr',SLOT_Talk);
}

function ImplantAnimation()
{
	if ( (ImplantPawn.Physics == PHYS_Walking) && (VSize(ImplantPawn.Velocity) > 0) && bWalk && (ImplantPawn.AnimSequence != 'Walk') && (ImplantPawn.AnimSequence != 'WalkFire') && !bStay )
	ImplantPawn.LoopAnim('Walk',1.0,0.1);
	else if ( (ImplantPawn.Physics == PHYS_Walking) && (VSize(ImplantPawn.Velocity) > 0) && !bWalk && (ImplantPawn.AnimSequence != 'Run') && !bStay )
	ImplantPawn.LoopAnim('Run',1.0,0.1);
	else if ( (ImplantPawn.Physics == PHYS_Swimming) && (ImplantPawn.AnimSequence != 'Swim') && (ImplantPawn.AnimSequence != 'SwimFire') && !bStay )
	ImplantPawn.LoopAnim('Swim',1.0,0.1);
	else if ( (ImplantPawn.Physics == PHYS_Walking) && (VSize(ImplantPawn.Velocity) == 0) && (ImplantPawn.AnimSequence != 'Breath') && (ImplantPawn.AnimSequence != 'Dance') && (ImplantPawn.AnimSequence != 'Shoot') && (ImplantPawn.AnimSequence != 'Spray') && (ImplantPawn.AnimSequence != 'Swat') && (ImplantPawn.AnimSequence != 'Punch') )
	ImplantPawn.LoopAnim('Breath',0.5,0.1);

	if ( ((ImplantPawn.AnimSequence == 'Breath') || (ImplantPawn.AnimSequence == 'Swim')) && bStay )
	bStay = False;
}

defaultproperties
{
     bCanJump=True
     bCanDodge=True
     WaterJumpZ=440.000000
}
