//=============================================================================
// IG_Minotaur.
//=============================================================================
class IG_Minotaur expands IG_Handler;

var sound RoarSound, SwingSound, JumpSound, StepSound;
var bool bRoaring, bBigMinotaur;
var float LastStep;
var byte SwingDamage;

function ImplantFire()
{
	if ( (ImplantPawn.Physics != PHYS_Falling) && ((ImplantPawn.AnimSequence == 'Breathe') || (ImplantPawn.AnimSequence == 'Walk') || (ImplantPawn.AnimSequence == 'Charging') || (ImplantPawn.AnimSequence == 'ChargeHitTarget')) )
	{
		if ( (Controller.bDuck > 0) && (ImplantPawn.Physics != PHYS_Swimming) )
		{
			bStay = True;

			bRoaring = True;

			SetTimer(1.5,False);

			ImplantPawn.LoopAnim('Roaring',1.0,0.05);

			if ( RoarSound != None )
			ImplantPawn.PlaySound(RoarSound,SLOT_Talk);

			return;
		}

		FindTarget();

		if ( ImplantPawn.Target == None )
		return;

		bStay = True;

		ImplantPawn.LoopAnim('SwingAxe',1.0,0.05);

		if ( SwingSound != None )
		ImplantPawn.PlaySound(SwingSound,SLOT_Interact);

		GotoState('ImplantFiring','SwingAxe');
	}
}

state ImplantFiring
{
	function AnimCheck(name Anim)
	{
		if ( Anim != ImplantPawn.AnimSequence )
		return;

		FindTarget();

		if ( !b227 && (ImplantPawn.Target == None) )
		ImplantPawn.LoopAnim('Breathe',0.5,0.2);
		else if ( (ImplantPawn.Target == None) || (ImplantPawn.Target == Level) || (Mover(ImplantPawn.Target) != None) )
		WallTarget();
		else
		ImplantPawn.MeleeDamageTarget(SwingDamage,SwingDamage*500*Normal(ImplantPawn.Target.Location-ImplantPawn.Location));
	}

	function WallTarget()
	{
		if ( (Mover(ImplantPawn.Target) != None) && Mover(ImplantPawn.Target).bDamageTriggered )
		ImplantPawn.Target.TakeDamage(SwingDamage,ImplantPawn,ImplantPawn.Target.Location,vect(0,0,0),'Hacked');
	}

SwingAxe:
	Sleep(0.3);
	AnimCheck('SwingAxe');
	Goto('End');
}

function Timer()
{
	bRoaring = False;
}

function HandlePawn(float DeltaTime)
{
	local float StepTime;

	if ( StepSound == None )
	return;

	if ( ImplantPawn.AnimSequence == 'Walk' )
	StepTime = 0.5;
	else if ( ImplantPawn.AnimSequence == 'Charging' )
	StepTime = 0.2;
	else
	return;

	if ( Level.TimeSeconds-LastStep < StepTime )
	return;

	LastStep = Level.TimeSeconds;

	if ( bBigMinotaur )
	ImplantPawn.PlaySound(StepSound,SLOT_Interact,0.8,,1200,0.7+FRand()/3);
	else
	ImplantPawn.PlaySound(StepSound,SLOT_Interact,0.6,,800,0.7+FRand()/3);
}

function PlayJump()
{
	ImplantPawn.PlayAnim('ChargeHitTarget',1.0);

	if ( JumpSound != None )
	ImplantPawn.PlaySound(JumpSound,SLOT_Talk);
}

function PlayDodge(string Dir)
{
	PlayJump();
}

function ImplantAnimation()
{
	if ( (ImplantPawn.Physics == PHYS_Walking) && (VSize(ImplantPawn.Velocity) > 0) && bWalk && (ImplantPawn.AnimSequence != 'Walk') && !bStay )
	ImplantPawn.LoopAnim('Walk',1.0,0.1);
	else if ( (ImplantPawn.Physics == PHYS_Walking) && (VSize(ImplantPawn.Velocity) > 0) && !bWalk && (ImplantPawn.AnimSequence != 'Charging') && !bStay )
	ImplantPawn.LoopAnim('Charging',1.0,0.1);
	else if ( (ImplantPawn.Physics == PHYS_Swimming) && (ImplantPawn.AnimSequence != 'ChargeHitTarget') && !bStay )
	ImplantPawn.LoopAnim('ChargeHitTarget',0.5,0.1);
	else if ( (ImplantPawn.Physics == PHYS_Walking) && (VSize(ImplantPawn.Velocity) == 0) && (ImplantPawn.AnimSequence != 'Breathe') && (ImplantPawn.AnimSequence != 'SwingAxe') && !bRoaring )
	ImplantPawn.LoopAnim('Breathe',0.5,0.1);

	if ( ((ImplantPawn.AnimSequence == 'Breathe') || (ImplantPawn.AnimSequence == 'ChargeHitTarget') || (ImplantPawn.AnimSequence == 'Roaring')) && bStay && !bRoaring )
	bStay = False;
}

function Initialize()
{
	Super.Initialize();

	SwingDamage = 26;

	RoarSound = Sound(DynamicLoadObject("PSXMinotaur.MinoRoar",class'Sound'));

	SwingSound = Sound(DynamicLoadObject("PSXMinotaur.MinoAtck",class'Sound'));

	JumpSound = Sound(DynamicLoadObject("PSXMinotaur.MinoHit",class'Sound'));

	StepSound = Sound(DynamicLoadObject("PSXMinotaur.MWalkStep",class'Sound'));

	if ( Caps(String(ImplantPawn.Class)) != "PSXMINOTAUR.BIGMINOTAUR" )
	return;

	bBigMinotaur = True;

	SwingDamage = 76;

	StepSound = Sound(DynamicLoadObject("PSXMinotaur.MBigStep",class'Sound'));

	WaterJumpZ = 580;

	ImplantPawn.AccelRate = ImplantPawn.default.AccelRate*2.4;

	ImplantPawn.GroundSpeed = ImplantPawn.default.GroundSpeed*4.8;

	ImplantPawn.WaterSpeed = ImplantPawn.default.WaterSpeed*2.4;

	ImplantPawn.Buoyancy = ImplantPawn.Mass;

	ImplantPawn.JumpZ = ImplantPawn.default.JumpZ*1.2;

	ImplantPawn.MaxStepHeight = ImplantPawn.default.MaxStepHeight*2.4;

	ImplantPawn.MeleeRange = ImplantPawn.default.MeleeRange*1.1;
}

function Destroyed()
{
	Super.Destroyed();

	if ( (ImplantPawn == None) || (ImplantPawn.Health < 1) || ImplantPawn.bDeleteMe || !bBigMinotaur )
	return;

	ImplantPawn.AccelRate = ImplantPawn.default.AccelRate;

	ImplantPawn.GroundSpeed = ImplantPawn.default.GroundSpeed;

	ImplantPawn.WaterSpeed = ImplantPawn.default.WaterSpeed;

	ImplantPawn.Buoyancy = ImplantPawn.default.Buoyancy;

	ImplantPawn.JumpZ = ImplantPawn.default.JumpZ;

	ImplantPawn.MaxStepHeight = ImplantPawn.default.MaxStepHeight;

	ImplantPawn.MeleeRange = ImplantPawn.default.MeleeRange;
}

defaultproperties
{
     bCanJump=True
     bCanDodge=True
}
