//=============================================================================
// IG_Nali.
//=============================================================================
class IG_Nali expands IG_Handler;

var bool bQuiet;

function ImplantFire()
{
	if ( (ImplantPawn.Physics == PHYS_Walking) && !ImplantPawn.Region.Zone.bWaterZone && ((ImplantPawn.AnimSequence == 'Breath') || (ImplantPawn.AnimSequence == 'Walk') || (ImplantPawn.AnimSequence == 'Run') || (ImplantPawn.AnimSequence == 'Backup')) )
	{
		bStay = True;

		if ( Controller.bDuck > 0 )
		{
			ImplantPawn.LoopAnim('Follow',1.0,0.05);

			ImplantPawn.PlaySound(Nali(ImplantPawn).UrgeFollow,SLOT_Talk);

			return;
		}

		if ( ImplantPawn.RangedProjectile != None )
		{
			ImplantPawn.LoopAnim('Spell',FClamp(ImplantPawn.RefireRate,1,5),0.05);

			GotoState('ImplantFiring','ProjFire');

			return;
		}

		if ( Controller.bRun > 0 )
		{
			ImplantPawn.LoopAnim('Cough',1.0,0.05);

			ImplantPawn.PlaySound(Nali(ImplantPawn).Cough,SLOT_Talk);

			return;
		}

		ImplantPawn.LoopAnim('Sweat',1.0,0.05);

		ImplantPawn.PlaySound(Nali(ImplantPawn).Sweat,SLOT_Talk);
	}
}

state ImplantFiring
{

ProjFire:
	Sleep(0.05+0.8/FClamp(ImplantPawn.RefireRate,1,5));
	if ( ImplantPawn.AnimSequence == 'Spell' )
	SpawnProjectile();
	Goto('End');
}

function ImplantAnimation()
{
	if ( (ImplantPawn.Physics == PHYS_Walking) && (VSize(ImplantPawn.Velocity) > 0) && bWalk && (ImplantPawn.AnimSequence != 'Walk') && (ImplantPawn.AnimSequence != 'Backup') && !bStay )
	{
		if ( (Controller.bDuck > 0) && bWasBack )
		ImplantPawn.LoopAnim('Backup',1.0,0.1);
		else
		ImplantPawn.LoopAnim('Walk',1.0,0.1);
	}
	else if ( (ImplantPawn.Physics == PHYS_Walking) && (VSize(ImplantPawn.Velocity) > 0) && !bWalk && (ImplantPawn.AnimSequence != 'Run') && !bStay )
		ImplantPawn.LoopAnim('Run',1.0,0.1);
	else if ( (ImplantPawn.Physics == PHYS_Swimming) && (ImplantPawn.AnimSequence != 'Drowning') && !bStay )
		ImplantPawn.LoopAnim('Drowning',1.0,0.1);
	else if ( (ImplantPawn.Physics == PHYS_Walking) && (VSize(ImplantPawn.Velocity) == 0) && (ImplantPawn.AnimSequence != 'Breath') && (ImplantPawn.AnimSequence != 'Follow') && (ImplantPawn.AnimSequence != 'Cough') && ((ImplantPawn.AnimSequence != 'Sweat') || !bStay) && (ImplantPawn.AnimSequence != 'Spell') )
		ImplantPawn.LoopAnim('Breath',0.5,0.1);

	if ( ((ImplantPawn.AnimSequence == 'Breath') || (ImplantPawn.AnimSequence == 'Drowning')) && bStay )
	bStay = False;
}

function PlayJump()
{
	ImplantPawn.PlayAnim('GutHit',1.0,0.1);

	ImplantPawn.PlaySound(Sound'syl2n',SLOT_Talk);
}

function HandlePawn(float DeltaTime)
{
	ImplantPawn.bQuiet = True;
}

function Initialize()
{
	Super.Initialize();

	bQuiet = ImplantPawn.bQuiet;

	ImplantPawn.bCanJump = True;

	ImplantPawn.JumpZ = 325;
}

function Destroyed()
{
	Super.Destroyed();

	if ( (ImplantPawn != None) && (ImplantPawn.Health > 0) && !ImplantPawn.bDeleteMe )
	{
		ImplantPawn.bQuiet = bQuiet;

		ImplantPawn.bCanJump = ImplantPawn.default.bCanJump;

		ImplantPawn.JumpZ = ImplantPawn.default.JumpZ;
	}
}

defaultproperties
{
     bCanJump=True
     FireOffset=(X=14.000000,Y=0.000000,Z=16.000000)
}
