//=============================================================================
// IG_Queen.
//=============================================================================
class IG_Queen expands IG_Handler;

var class<ScriptedPawn> BabyClass;
var vector TeleportDestination;

function ImplantFire()
{
	local float f;

	if ( (ImplantPawn.Physics != PHYS_Falling) && ((ImplantPawn.AnimSequence == 'Meditate') || (ImplantPawn.AnimSequence == 'Walk') || (ImplantPawn.AnimSequence == 'Run')) && !ImplantPawn.IsInState('Teleporting') )
	{
		bStay = True;

		if ( Controller.bDuck > 0 )
		{
			if ( TeleportDestination == vect(0,0,0) )
			{
				ImplantPawn.LoopAnim('Shield',1.0,0.05);

				GotoState('ImplantFiring','TeleDest');
			}
			else
			{
				bStay = False;

				ImplantPawn.GotoState('Teleporting');

				Queen(ImplantPawn).TelepDest = TeleportDestination;

				TeleportDestination = vect(0,0,0);
			}

			return;
		}

		if ( Controller.bRun > 0 )
		{
			ImplantPawn.LoopAnim('Scream',1.0,0.05);

			ImplantPawn.PlaySound(Sound'yell2Q',SLOT_Talk);

			GotoState('ImplantFiring','Birth');

			return;
		}

		FindTarget();

		if ( ImplantPawn.Target != None )
		{
			f = FRand();

			if ( f < 0.4 )
			{
				ImplantPawn.LoopAnim('Stab',1.0,0.05);

				ImplantPawn.PlaySound(Queen(ImplantPawn).Stab,SLOT_Interact);

				GotoState('ImplantFiring','Stab');
			}
			else if ( f < 0.7 )
			{
				ImplantPawn.LoopAnim('Claw',1.0,0.05);

				ImplantPawn.PlaySound(Queen(ImplantPawn).Claw,SLOT_Interact);

				GotoState('ImplantFiring','Claw');
			}
			else
			{
				ImplantPawn.LoopAnim('Gouge',1.0,0.05);

				ImplantPawn.PlaySound(Queen(ImplantPawn).Claw,SLOT_Interact);

				GotoState('ImplantFiring','Gouge');
			}

			return;
		}

		ImplantPawn.LoopAnim('Shoot1',1.0,0.05);

		ImplantPawn.PlaySound(Queen(ImplantPawn).Shoot,SLOT_Interact);

		Queen(ImplantPawn).row = 0;
	}
}

state ImplantFiring
{
	function AnimCheck(name Anim)
	{
		if ( Anim != ImplantPawn.AnimSequence )
		return;

		FindTarget();

		if ( !b227 && (ImplantPawn.Target == None) )
		ImplantPawn.LoopAnim('Meditate',0.5,0.2);
		else if ( (ImplantPawn.Target == Level) || (Mover(ImplantPawn.Target) != None) )
		WallTarget();
	}

	function WallTarget()
	{
		if ( (Mover(ImplantPawn.Target) != None) && Mover(ImplantPawn.Target).bDamageTriggered )
		ImplantPawn.Target.TakeDamage(Queen(ImplantPawn).ClawDamage,ImplantPawn,ImplantPawn.Target.Location,vect(0,0,0),'Hacked');
	}

	function SpawnBaby()
	{
		local ScriptedPawn P;
		local bool bOldCollideActors;

		if ( BabyClass == None )
		return;

		bOldCollideActors = ImplantPawn.bCollideActors;

		ImplantPawn.SetCollision(False);

		P = Spawn(BabyClass,,,ImplantPawn.Location-ImplantPawn.CollisionRadius*Vector(ImplantPawn.Rotation),Rotator(-1*Vector(ImplantPawn.Rotation)));

		ImplantPawn.SetCollision(bOldCollideActors);

		if ( P == None )
		return;

		P.GotoState('Roaming');
		P.Velocity = 300*Vector(P.Rotation);

		if ( P.Physics == PHYS_None )
		P.SetMovementPhysics();

		Spawn(class'BloodSpray',,,ImplantPawn.Location-ImplantPawn.CollisionRadius*Vector(ImplantPawn.Rotation)*0.8,RotRand());
	}

TeleDest:
	Sleep(0.5);
	if ( ImplantPawn.AnimSequence == 'Shield' )
	TeleportDestination = ImplantPawn.Location;
	Goto('End');

Birth:
	Sleep(0.3);
	if ( ImplantPawn.AnimSequence == 'Scream' )
	SpawnBaby();
	Goto('End');

Stab:
	Sleep(0.18);
	AnimCheck('Stab');
	Goto('End');

Claw:
	Sleep(0.34);
	AnimCheck('Claw');
	Goto('End');

Gouge:
	Sleep(0.34);
	AnimCheck('Gouge');
	Goto('End');
}

function HandlePawn(float DeltaTime)
{
	if ( (Queen(ImplantPawn).Shield != None) && !Queen(ImplantPawn).Shield.bDeleteMe )
	Queen(ImplantPawn).Shield.Destroy();
}

function PlayJump()
{
	ImplantPawn.PlaySound(Sound'yell1Q',SLOT_Talk);
}

function ImplantAnimation()
{
	if ( (ImplantPawn.Physics == PHYS_Walking) && (VSize(ImplantPawn.Velocity) > 0) && bWalk && (ImplantPawn.AnimSequence != 'Walk') && !bStay )
	ImplantPawn.LoopAnim('Walk',1.0,0.1);
	else if ( (ImplantPawn.Physics == PHYS_Walking) && (VSize(ImplantPawn.Velocity) > 0) && !bWalk && (ImplantPawn.AnimSequence != 'Run') && !bStay )
	ImplantPawn.LoopAnim('Run',1.0,0.1);
	else if ( (ImplantPawn.Physics == PHYS_Walking) && (VSize(ImplantPawn.Velocity) == 0) && (ImplantPawn.AnimSequence != 'Meditate') && (ImplantPawn.AnimSequence != 'Scream') && (ImplantPawn.AnimSequence != 'Shield') && (ImplantPawn.AnimSequence != 'Stab') && (ImplantPawn.AnimSequence != 'Claw') && (ImplantPawn.AnimSequence != 'Gouge') && (ImplantPawn.AnimSequence != 'Shoot1') )
	ImplantPawn.LoopAnim('Meditate',0.5,0.1);

	if ( (ImplantPawn.AnimSequence == 'Meditate') && bStay )
	bStay = False;
}

defaultproperties
{
     BabyClass=Class'Pupae'
     bCanJump=True
     bCanSwim=False
     IgnoreState=Teleporting
}
