//=============================================================================
// IG_SkaarjTrooper.
//=============================================================================
class IG_SkaarjTrooper expands IG_Handler;

var Weapon Weapon;
var bool bFiring;
var float LastToss;

function ImplantFire()
{
	if ( (ImplantPawn.Physics != PHYS_Falling) && ((ImplantPawn.AnimSequence == 'Breath2') || (ImplantPawn.AnimSequence == 'Walk') || (ImplantPawn.AnimSequence == 'Jog') || (ImplantPawn.AnimSequence == 'Swim')) )
	{
		if ( (Weapon == None) && (Controller.bDuck > 0) && (Level.TimeSeconds-LastToss > 0.5) && CloseToWeapon() )
		return;

		if ( (Weapon != None) && (Controller.bDuck > 0) && bWalk && bWasBack )
		{
			LastToss = Level.TimeSeconds;

			Weapon.DrawType = Weapon.default.DrawType;

			Weapon.Velocity = Vector(ImplantPawn.Rotation)*250+vect(0,0,200);

			Weapon.bTossedOut = True;

			Weapon = None;

			ImplantPawn.TossWeapon();

			return;
		}

		FindTarget();

		if ( ImplantPawn.Target != None )
		{
			ImplantMelee();

			return;
		}

		if ( (Weapon == None) || bFiring )
		return;

		bFiring = True;

		if ( Controller.bDuck == 0 )
		{
			ImplantPawn.bFire = 1;

			Weapon.Fire(1);
		}
		else
		{
			ImplantPawn.bAltFire = 1;

			Weapon.AltFire(1);
		}
	}
}

state ImplantFiring
{
	function AnimCheck(name Anim)
	{
		if ( Anim != ImplantPawn.AnimSequence )
		return;

		FindTarget();

		if ( !b227 && (ImplantPawn.Target == None) )
		ImplantPawn.LoopAnim('Breath2',0.5,0.2);
		else if ( (ImplantPawn.Target == Level) || (Mover(ImplantPawn.Target) != None) )
		WallTarget();
	}

	function WallTarget()
	{
		ImplantPawn.PlaySound(SkaarjTrooper(ImplantPawn).Slice,SLOT_Interact);

		if ( (Mover(ImplantPawn.Target) != None) && Mover(ImplantPawn.Target).bDamageTriggered )
		ImplantPawn.Target.TakeDamage(SkaarjTrooper(ImplantPawn).ClawDamage,ImplantPawn,ImplantPawn.Target.Location,vect(0,0,0),'Hacked');
	}

Spin:
	Sleep(0.34);
	AnimCheck('spin');
	Sleep(0.14);
	AnimCheck('spin');
	Goto('End');

Claw:
	Sleep(0.2);
	AnimCheck('claw');
	Sleep(0.46);
	AnimCheck('claw');
	Goto('End');

Lunge:
	Sleep(0.16);
	FindTarget();
	if ( (ImplantPawn.AnimSequence == 'lunge') && (ImplantPawn.Target != None) && ImplantPawn.MeleeDamageTarget(SkaarjTrooper(ImplantPawn).LungeDamage,(SkaarjTrooper(ImplantPawn).LungeDamage*2000*Normal(ImplantPawn.Target.Location-ImplantPawn.Location))) )
	ImplantPawn.Target.PlaySound(SkaarjTrooper(ImplantPawn).Slice,SLOT_Interact);
	Goto('End');
}

function ImplantMelee()
{
	bStay = True;

	if ( FRand() < 0.33 )
	{
		ImplantPawn.LoopAnim('spin',1.0,0.05);

		ImplantPawn.PlaySound(SkaarjTrooper(ImplantPawn).spin,SLOT_Interact);

		GotoState('ImplantFiring','Spin');
	}
	else
	{
		ImplantPawn.LoopAnim('claw',1.0,0.05);

		ImplantPawn.PlaySound(SkaarjTrooper(ImplantPawn).claw,SLOT_Interact);

		GotoState('ImplantFiring','Claw');
	}
}

function HandlePawn(float DeltaTime)
{
	Weapon = ImplantPawn.Weapon;

	if ( Weapon != None )
	Weapon.DrawType = DT_None;

	if ( (Weapon == None) || (ImplantPawn.Physics == PHYS_Falling) || bStay )
	{
		bFiring = False;

		ImplantPawn.bFire = 0;
		ImplantPawn.bAltFire = 0;

		return;
	}

	if ( (Controller.bFire > 0) && ((ImplantPawn.AnimSequence == 'Breath2') || (ImplantPawn.AnimSequence == 'Walk') || (ImplantPawn.AnimSequence == 'Jog') || (ImplantPawn.AnimSequence == 'Swim')) )
	FindTarget();

	if ( ImplantPawn.Target != None )
	{
		ImplantMelee();

		return;
	}

	ImplantPawn.ViewRotation = ImplantPawn.Rotation;

	if ( Weapon.AmmoType != None )
	Weapon.AmmoType.AmmoAmount = Weapon.AmmoType.default.AmmoAmount;

	if ( AutoMag(Weapon) != None )
	AutoMag(Weapon).ClipCount = 0;

	ImplantPawn.bFire = Byte(Bool(Controller.bFire) && !Bool(Controller.bDuck));
	ImplantPawn.bAltFire = Byte(Bool(Controller.bFire) && Bool(Controller.bDuck));

	bFiring = (ImplantPawn.bFire > 0) || (ImplantPawn.bAltFire > 0) || Weapon.IsInState('NormalFire') || Weapon.IsInState('AltFiring');

	if ( !bFiring || !Weapon.IsInState('Idle') )
	return;

	if ( Controller.bDuck == 0 )
	Weapon.Fire(1);
	else
	Weapon.AltFire(1);
}

function bool CloseToWeapon()
{
	local Weapon Wep;

	ForEach VisibleCollidingActors( class'Weapon', Wep, ImplantPawn.CollisionRadius*1.5, ImplantPawn.Location-ImplantPawn.CollisionHeight/2*vect(0,0,1) )
	{
		bStay = True;

		ImplantPawn.LoopAnim('Pickup',1.0,0.05);

		SetTimer(0.5,False);

		return True;
	}

	return False;
}

function Timer()
{
	local Weapon Wep, NewWep;

	if ( ImplantPawn.AnimSequence == 'Pickup' )
	ForEach VisibleCollidingActors( class'Weapon', Wep, ImplantPawn.CollisionRadius*1.5, ImplantPawn.Location-ImplantPawn.CollisionHeight/2*vect(0,0,1) )
	{
		if ( Wep.RespawnTime == 0 )
		{
			NewWep = Spawn(Wep.Class,,,ImplantPawn.Location);

			NewWep.RespawnTime = 0;

			Wep.Destroy();

			Wep = NewWep;
		}

		ImplantPawn.bIsPlayer = True;

		Wep.Touch(ImplantPawn);

		ImplantPawn.bIsPlayer = False;

		break;
	}

	if ( ImplantPawn.Weapon != None )
	ImplantPawn.Weapon.DrawType = DT_None;
}

function PlayJump()
{
	ImplantPawn.PlaySound(Sound'SKPJump1',SLOT_Talk);
}

function PlayDodge(string Dir)
{
	if ( Dir ~= "FORWARD" )
	{
		ImplantPawn.PlayAnim('lunge',2.0,0.05);

		ImplantPawn.PlaySound(SkaarjTrooper(ImplantPawn).lunge,SLOT_Talk);

		GotoState('ImplantFiring','Lunge');
	}
	else if ( Dir ~= "BACK" )
	{
		ImplantPawn.PlayAnim('Jump2',1.0,0.05);

		ImplantPawn.PlaySound(Sound'SKPJump1',SLOT_Talk);
	}
	else if ( Dir ~= "LEFT" )
	{
		ImplantPawn.PlayAnim('LeftDodge',2.0,0.05);

		ImplantPawn.PlaySound(Sound'SKPJump1',SLOT_Talk);
	}
	else if ( Dir ~= "RIGHT" )
	{
		ImplantPawn.PlayAnim('RightDodge',2.0,0.05);

		ImplantPawn.PlaySound(Sound'SKPJump1',SLOT_Talk);
	}
}

function ImplantAnimation()
{
	if ( (ImplantPawn.Physics == PHYS_Walking) && (VSize(ImplantPawn.Velocity) > 0) && bWalk && (ImplantPawn.AnimSequence != 'Walk') && !bStay && !bFiring )
	ImplantPawn.LoopAnim('Walk',1.0,0.1);
	else if ( (ImplantPawn.Physics == PHYS_Walking) && (VSize(ImplantPawn.Velocity) > 0) && bWalk && (ImplantPawn.AnimSequence != 'WalkFire') && !bStay && bFiring )
	ImplantPawn.LoopAnim('WalkFire',1.0,0.1);
	else if ( (ImplantPawn.Physics == PHYS_Walking) && (VSize(ImplantPawn.Velocity) > 0) && !bWalk && (ImplantPawn.AnimSequence != 'Jog') && !bStay && !bFiring )
	ImplantPawn.LoopAnim('Jog',1.0,0.1);
	else if ( (ImplantPawn.Physics == PHYS_Walking) && (VSize(ImplantPawn.Velocity) > 0) && !bWalk && (ImplantPawn.AnimSequence != 'JogFire') && !bStay && bFiring )
	ImplantPawn.LoopAnim('JogFire',1.0,0.1);
	else if ( (ImplantPawn.Physics == PHYS_Swimming) && (ImplantPawn.AnimSequence != 'Swim') && !bStay )
	ImplantPawn.LoopAnim('Swim',1.0,0.1);
	else if ( (ImplantPawn.Physics == PHYS_Walking) && (VSize(ImplantPawn.Velocity) == 0) && (ImplantPawn.AnimSequence != 'Firing') && (ImplantPawn.AnimSequence != 'claw') && (ImplantPawn.AnimSequence != 'spin') && (ImplantPawn.AnimSequence != 'Pickup') && bFiring )
	ImplantPawn.LoopAnim('Firing',0,0);
	else if ( (ImplantPawn.Physics == PHYS_Walking) && (VSize(ImplantPawn.Velocity) == 0) && (ImplantPawn.AnimSequence != 'Breath2') && (ImplantPawn.AnimSequence != 'claw') && (ImplantPawn.AnimSequence != 'spin') && (ImplantPawn.AnimSequence != 'Pickup') && !bFiring )
	ImplantPawn.LoopAnim('Breath2',0.5,0.1);

	if ( ((ImplantPawn.AnimSequence == 'Breath2') || (ImplantPawn.AnimSequence == 'Swim')) && bStay )
	bStay = False;
}

function Initialize()
{
	local Weapon Wep;

	Super.Initialize();

	if ( ImplantPawn.Weapon != None )
	{
		Wep = Spawn(ImplantPawn.Weapon.Class,,,ImplantPawn.Location);

		Wep.RespawnTime = 0;

		ImplantPawn.Weapon.Destroy();

		ImplantPawn.bIsPlayer = True;

		Wep.Touch(ImplantPawn);
	}

	ImplantPawn.bIsPlayer = False;
}

function Destroyed()
{
	Super.Destroyed();

	if ( Weapon != None )
	Weapon.DrawType = Weapon.default.DrawType;

	if ( (ImplantPawn == None) || (ImplantPawn.Health < 1) || ImplantPawn.bDeleteMe )
	return;

	ImplantPawn.bFire = 0;
	ImplantPawn.bAltFire = 0;

	if ( Weapon != None )
	return;

	ImplantPawn.bHasRangedAttack = False;
	ImplantPawn.bMovingRangedAttack = False;
}

defaultproperties
{
     bCanJump=True
     bCanDodge=True
}
