//=============================================================================
// IG_SkaarjWarrior.
//=============================================================================
class IG_SkaarjWarrior expands IG_Handler;

function ImplantFire()
{
	if ( (ImplantPawn.Physics != PHYS_Falling) && ((ImplantPawn.AnimSequence == 'Breath2') || (ImplantPawn.AnimSequence == 'Walk') || (ImplantPawn.AnimSequence == 'Jog') || (ImplantPawn.AnimSequence == 'Swim')) )
	{
		if ( (Controller.bDuck > 0) && (ImplantPawn.Physics != PHYS_Swimming) && (VSize(ImplantPawn.Velocity) == 0) )
		{
			bStay = True;

			ImplantPawn.LoopAnim('Stretch',1.0,0.05);

			return;
		}

		FindTarget();

		if ( ImplantPawn.Target != None )
		{
			bStay = True;

			if ( FRand() < 0.33 )
			{
				ImplantPawn.LoopAnim('spin',1.0,0.05);

				ImplantPawn.PlaySound(SkaarjWarrior(ImplantPawn).spin,SLOT_Interact);

				GotoState('ImplantFiring','Spin');
			}
			else
			{
				ImplantPawn.LoopAnim('claw',1.0,0.05);

				ImplantPawn.PlaySound(SkaarjWarrior(ImplantPawn).claw,SLOT_Interact);

				GotoState('ImplantFiring','Claw');
			}

			return;
		}

		if ( ImplantPawn.Physics == PHYS_Swimming )
			ImplantPawn.LoopAnim('SwimFire',1.0,0.05);
		else if ( VSize(ImplantPawn.Velocity) > 0 )
		{
			if ( bWalk )
			ImplantPawn.LoopAnim('WalkFire',1.0,0.05);
			else
			ImplantPawn.LoopAnim('JogFire',1.0,0.05);
		}
		else
			ImplantPawn.LoopAnim('Firing',1.0,0.05);
	}
}

state ImplantFiring
{
	function AnimCheck(name Anim)
	{
		if ( Anim != ImplantPawn.AnimSequence )
		return;

		FindTarget();

		if ( !b227 && (ImplantPawn.Target == None) )
		ImplantPawn.LoopAnim('Breath2',0.5,0.2);
		else if ( (ImplantPawn.Target == Level) || (Mover(ImplantPawn.Target) != None) )
		WallTarget();
	}

	function WallTarget()
	{
		ImplantPawn.PlaySound(SkaarjWarrior(ImplantPawn).Slice,SLOT_Interact);

		if ( (Mover(ImplantPawn.Target) != None) && Mover(ImplantPawn.Target).bDamageTriggered )
		ImplantPawn.Target.TakeDamage(SkaarjWarrior(ImplantPawn).ClawDamage,ImplantPawn,ImplantPawn.Target.Location,vect(0,0,0),'Hacked');
	}

Spin:
	Sleep(0.34);
	AnimCheck('spin');
	Sleep(0.14);
	AnimCheck('spin');
	Goto('End');

Claw:
	Sleep(0.18);
	AnimCheck('claw');
	Sleep(0.4);
	AnimCheck('claw');
	Goto('End');

Lunge:
	Sleep(0.16);
	FindTarget();
	if ( (ImplantPawn.AnimSequence == 'lunge') && (ImplantPawn.Target != None) && ImplantPawn.MeleeDamageTarget(SkaarjWarrior(ImplantPawn).LungeDamage,(SkaarjWarrior(ImplantPawn).LungeDamage*2000*Normal(ImplantPawn.Target.Location-ImplantPawn.Location))) )
	ImplantPawn.Target.PlaySound(SkaarjWarrior(ImplantPawn).Slice,SLOT_Interact);
	Goto('End');
}

function PlayJump()
{
	ImplantPawn.PlaySound(Sound'SKPJump1',SLOT_Talk);
}

function PlayDodge(string Dir)
{
	if ( Dir ~= "FORWARD" )
	{
		ImplantPawn.PlayAnim('lunge',2.0,0.05);

		ImplantPawn.PlaySound(SkaarjWarrior(ImplantPawn).lunge,SLOT_Talk);

		GotoState('ImplantFiring','Lunge');
	}
	else if ( Dir ~= "BACK" )
	{
		ImplantPawn.PlayAnim('Jump2',1.0,0.05);

		ImplantPawn.PlaySound(Sound'SKPJump1',SLOT_Talk);
	}
	else if ( Dir ~= "LEFT" )
	{
		ImplantPawn.PlayAnim('LeftDodge',2.0,0.05);

		ImplantPawn.PlaySound(Sound'SKPJump1',SLOT_Talk);
	}
	else if ( Dir ~= "RIGHT" )
	{
		ImplantPawn.PlayAnim('RightDodge',2.0,0.05);

		ImplantPawn.PlaySound(Sound'SKPJump1',SLOT_Talk);
	}
}

function ImplantAnimation()
{
	if ( (ImplantPawn.Physics == PHYS_Walking) && (VSize(ImplantPawn.Velocity) > 0) && bWalk && (ImplantPawn.AnimSequence != 'Walk') && (ImplantPawn.AnimSequence != 'WalkFire') && !bStay )
	ImplantPawn.LoopAnim('Walk',1.0,0.1);
	else if ( (ImplantPawn.Physics == PHYS_Walking) && (VSize(ImplantPawn.Velocity) > 0) && !bWalk && (ImplantPawn.AnimSequence != 'Jog') && (ImplantPawn.AnimSequence != 'JogFire') && !bStay )
	ImplantPawn.LoopAnim('Jog',1.0,0.1);
	else if ( (ImplantPawn.Physics == PHYS_Swimming) && (ImplantPawn.AnimSequence != 'Swim') && (ImplantPawn.AnimSequence != 'SwimFire') && !bStay )
	ImplantPawn.LoopAnim('Swim',1.0,0.1);
	else if ( (ImplantPawn.Physics == PHYS_Walking) && (VSize(ImplantPawn.Velocity) == 0) && (ImplantPawn.AnimSequence != 'Breath2') && (ImplantPawn.AnimSequence != 'Stretch') && (ImplantPawn.AnimSequence != 'Firing') && (ImplantPawn.AnimSequence != 'claw') && (ImplantPawn.AnimSequence != 'spin') )
	ImplantPawn.LoopAnim('Breath2',0.5,0.1);

	if ( ((ImplantPawn.AnimSequence == 'Breath2') || (ImplantPawn.AnimSequence == 'Swim')) && bStay )
	bStay = False;
}

defaultproperties
{
     bCanJump=True
     bCanDodge=True
}
