//=============================================================================
// IG_Slith.
//=============================================================================
class IG_Slith expands IG_Handler;

var sound ScratchSound, SlickSound;
var float LastSound;

function ImplantFire()
{
	if ( (ImplantPawn.Physics != PHYS_Falling) && ((ImplantPawn.AnimSequence == 'Breath') || (ImplantPawn.AnimSequence == 'Slither') || (ImplantPawn.AnimSequence == 'Swim')) )
	{
		bStay = True;

		if ( (Controller.bDuck > 0) && (ImplantPawn.Physics != PHYS_Swimming) )
		{
			ImplantPawn.LoopAnim('ChargeUp',0.5,0.2);

			ImplantPawn.PlaySound(ImplantPawn.Fear,SLOT_Talk);

			return;
		}

		FindTarget();

		if ( ImplantPawn.Target != None )
		{
			if ( ImplantPawn.Physics == PHYS_Swimming )
			{
				if ( FRand() < 0.5 )
				{
					ImplantPawn.LoopAnim('Claw1',1.0,0.05);

					GotoState('ImplantFiring','Claw1');
				}
				else
				{
					ImplantPawn.LoopAnim('Claw2',1.0,0.05);

					GotoState('ImplantFiring','Claw2');
				}
			}
			else
			{
				if ( FRand() < 0.5 )
				{
					ImplantPawn.LoopAnim('Slash',1.0,0.05);

					GotoState('ImplantFiring','Slash');
				}
				else
				{
					ImplantPawn.LoopAnim('Punch',1.0,0.05);

					GotoState('ImplantFiring','Punch');
				}
			}

			return;
		}

		if ( ImplantPawn.Physics == PHYS_Swimming )
		ImplantPawn.LoopAnim('Shoot2',1.0,0.05);
		else
		ImplantPawn.LoopAnim('Shoot1',1.0,0.05);
	}
}

state ImplantFiring
{
	function AnimCheck(name Anim)
	{
		if ( Anim != ImplantPawn.AnimSequence )
		return;

		FindTarget();

		if ( !b227 && (ImplantPawn.Target == None) )
		ImplantPawn.LoopAnim('Breath',0.5,0.2);
		else if ( (ImplantPawn.Target == Level) || (Mover(ImplantPawn.Target) != None) )
		WallTarget();
	}

	function WallTarget()
	{
		if ( (Mover(ImplantPawn.Target) != None) && Mover(ImplantPawn.Target).bDamageTriggered )
		ImplantPawn.Target.TakeDamage(Slith(ImplantPawn).ClawDamage,ImplantPawn,ImplantPawn.Target.Location,vect(0,0,0),'Hacked');
	}

Claw1:
	Sleep(0.3);
	AnimCheck('Claw1');
	Goto('End');

Claw2:
	Sleep(0.3);
	AnimCheck('Claw2');
	Goto('End');

Slash:
	Sleep(0.5);
	AnimCheck('Slash');
	Goto('End');

Punch:
	Sleep(0.5);
	AnimCheck('Punch');
	Goto('End');
}

function HandlePawn(float DeltaTime)
{
	local sound MoveSound;

	if ( VSize(ImplantPawn.Velocity) == 0 )
	return;

	if ( (ImplantPawn.AnimSequence == 'Slither') && !bWalk )
	MoveSound = Slith(ImplantPawn).Slither;
	else if ( ImplantPawn.AnimSequence == 'Swim' )
	MoveSound = Slith(ImplantPawn).Swim;
	else
	return;

	if ( Level.TimeSeconds-LastSound < 1 )
	return;

	LastSound = Level.TimeSeconds;

	ImplantPawn.PlaySound(MoveSound,SLOT_Interact);
}

function ImplantAnimation()
{
	if ( (ImplantPawn.Physics == PHYS_Walking) && (VSize(ImplantPawn.Velocity) > 0) && bWalk && (ImplantPawn.AnimSequence != 'Slither') && !bStay )
		ImplantPawn.LoopAnim('Slither',0.4,0.1);
	else if ( (ImplantPawn.Physics == PHYS_Walking) && (VSize(ImplantPawn.Velocity) > 0) && !bWalk && (ImplantPawn.AnimSequence != 'Slither') && !bStay )
		ImplantPawn.LoopAnim('Slither',1.0,0.1);
	else if ( (ImplantPawn.Physics == PHYS_Swimming) && !bStay )
	{
		if ( (ImplantPawn.AnimSequence == 'Swim') && (VSize(ImplantPawn.Velocity) > 0) && (ImplantPawn.AnimRate != 1) )
		ImplantPawn.LoopAnim('Swim',1.0);
		else if ( (ImplantPawn.AnimSequence != 'Swim') && (VSize(ImplantPawn.Velocity) > 0) )
		ImplantPawn.LoopAnim('Swim',1.0,0.1);
		else if ( (ImplantPawn.AnimSequence != 'Swim') && (VSize(ImplantPawn.Velocity) == 0) )
		ImplantPawn.LoopAnim('Swim',0.5,0.1);
	}
	else if ( (ImplantPawn.Physics == PHYS_Walking) && (VSize(ImplantPawn.Velocity) == 0) && (ImplantPawn.AnimSequence != 'Breath') && (ImplantPawn.AnimSequence != 'ChargeUp') && (ImplantPawn.AnimSequence != 'Shoot1') && (ImplantPawn.AnimSequence != 'Slash') && (ImplantPawn.AnimSequence != 'Punch') )
		ImplantPawn.LoopAnim('Breath',0.5,0.1);

	if ( ((ImplantPawn.AnimSequence == 'Breath') || (ImplantPawn.AnimSequence == 'Swim')) && bStay )
	bStay = False;
}

function Initialize()
{
	Super.Initialize();

	ScratchSound = Slith(ImplantPawn).Scratch;

	Slith(ImplantPawn).Scratch = None;

	SlickSound = Slith(ImplantPawn).Slick;

	Slith(ImplantPawn).Slick = None;
}

function Destroyed()
{
	Super.Destroyed();

	if ( (ImplantPawn != None) && (ImplantPawn.Health > 0) && !ImplantPawn.bDeleteMe )
	{
		Slith(ImplantPawn).Scratch = ScratchSound;
		Slith(ImplantPawn).Slick = SlickSound;
	}
}

defaultproperties
{
     bCanJump=True
}
