//=============================================================================
// IG_Titan.
//=============================================================================
class IG_Titan expands IG_Handler;

function ImplantFire()
{
	if ( (ImplantPawn.Physics == PHYS_Walking) && ((ImplantPawn.AnimSequence == 'TBrea001') || (ImplantPawn.AnimSequence == 'TWalk001')) )
	{
		bStay = True;

		if ( Controller.bDuck > 0 )
		{
			ImplantPawn.LoopAnim('TStom001',1.0,0.05);

			ImplantPawn.PlaySound(Titan(ImplantPawn).StompSound,SLOT_Interact);
			ImplantPawn.PlaySound(Titan(ImplantPawn).StompSound,SLOT_Misc);

			GotoState('ImplantFiring','Stomp');

			return;
		}

		if ( Controller.bRun > 0 )
		{
			ImplantPawn.LoopAnim('TChest',1.0,0.05);

			ImplantPawn.PlaySound(Titan(ImplantPawn).Chest,SLOT_Interact);
			ImplantPawn.PlaySound(Titan(ImplantPawn).Chest,SLOT_Misc);

			return;
		}

		FindTarget();

		if ( ImplantPawn.Target != None )
		{
			if ( FRand() < 0.6 )
			{
				ImplantPawn.LoopAnim('TPunc001',1.0,0.05);

				ImplantPawn.PlaySound(Sound'punch1Ti',SLOT_Interact);
				ImplantPawn.PlaySound(Sound'punch1Ti',SLOT_Misc);

				GotoState('ImplantFiring','Punch');
			}
			else
			{
				ImplantPawn.LoopAnim('TSlap001',1.0,0.05);

				ImplantPawn.PlaySound(Titan(ImplantPawn).Swing,SLOT_Interact);
				ImplantPawn.PlaySound(Titan(ImplantPawn).Swing,SLOT_Misc);

				GotoState('ImplantFiring','Slap');
			}

			return;
		}

		ImplantPawn.LoopAnim('TThro001',1.0,0.1);

		ImplantPawn.PlaySound(Titan(ImplantPawn).Throw,SLOT_Interact);
	}
}

state ImplantFiring
{
	function AnimCheck(name Anim)
	{
		if ( Anim != ImplantPawn.AnimSequence )
		return;

		FindTarget();

		if ( !b227 && (ImplantPawn.Target == None) )
		ImplantPawn.LoopAnim('TBrea001',0.5,0.2);
		else if ( (ImplantPawn.Target == Level) || (Mover(ImplantPawn.Target) != None) )
		WallTarget();
	}

	function WallTarget()
	{
		ImplantPawn.PlaySound(Titan(ImplantPawn).Slap,SLOT_Interact);
		ImplantPawn.PlaySound(Titan(ImplantPawn).Slap,SLOT_Misc);

		if ( (Mover(ImplantPawn.Target) != None) && Mover(ImplantPawn.Target).bDamageTriggered )
		ImplantPawn.Target.TakeDamage(Titan(ImplantPawn).SlapDamage,ImplantPawn,ImplantPawn.Target.Location,vect(0,0,0),'Hacked');
	}

	function Stomp()
	{
		local Actor A;
		local rotator StompRot;
		local vector StompLoc, X, Y, Z;

		StompRot.Yaw = ImplantPawn.Rotation.Yaw;

		GetAxes(StompRot,X,Y,Z);

		StompLoc = ImplantPawn.Location-(ImplantPawn.CollisionHeight-4)*vect(0,0,1)+ImplantPawn.CollisionRadius*0.3*X+ImplantPawn.CollisionRadius*0.35*Y;

		ForEach VisibleCollidingActors( class'Actor', A, ImplantPawn.CollisionRadius*0.56, StompLoc )
		if ( (Decoration(A) != None) || (Flare(A) != None) )
		A.TakeDamage(1000,ImplantPawn,A.Location,vect(0,0,-10000)+5000*X,'stomped');
	}

Stomp:
	Sleep(0.5);
	if ( ImplantPawn.AnimSequence == 'TStom001' )
	Stomp();
	Goto('End');

Punch:
	Sleep(0.54);
	AnimCheck('TPunc001');
	Goto('End');

Slap:
	Sleep(0.46);
	AnimCheck('TSlap001');
	Goto('End');
}

function ImplantAnimation()
{
	if ( (ImplantPawn.Physics == PHYS_Walking) && (VSize(ImplantPawn.Velocity) > 0) && (ImplantPawn.AnimSequence != 'TWalk001') && !bStay )
	{
		ImplantPawn.LoopAnim('TWalk001',1.0,0.1);

		ImplantPawn.DesiredSpeed = ImplantPawn.MaxDesiredSpeed;
	}
	else if ( (ImplantPawn.Physics == PHYS_Walking) && (VSize(ImplantPawn.Velocity) == 0) && (ImplantPawn.AnimSequence != 'TBrea001') && (ImplantPawn.AnimSequence != 'TThro001') && (ImplantPawn.AnimSequence != 'TPunc001') && (ImplantPawn.AnimSequence != 'TSlap001') && (ImplantPawn.AnimSequence != 'TStom001') && (ImplantPawn.AnimSequence != 'TChest') )
		ImplantPawn.LoopAnim('TBrea001',0.5,0.1);

	if ( (ImplantPawn.AnimSequence == 'TBrea001') && bStay )
	bStay = False;
}

defaultproperties
{
     bCanWalk=False
     bCanSwim=False
     bAdjustSpeed=False
}
