//=============================================================================
// ImplantGun.
//=============================================================================
class ImplantGun expands Weapon;

#EXEC OBJ LOAD FILE=Detail.utx
#EXEC TEXTURE IMPORT NAME=IG_WeaponSkin FILE=Textures\IG_WeaponSkin.pcx LODSET=2 DETAIL=metal

// PickupViewMesh
#EXEC MESH IMPORT MESH=IG_PickupViewMesh ANIVFILE=Models\IG_PickupViewMesh_a.3d DATAFILE=Models\IG_PickupViewMesh_d.3d
#EXEC MESH ORIGIN MESH=IG_PickupViewMesh X=-100 Y=-350 Z=0 PITCH=2 ROLL=-60
#EXEC MESH LODPARAMS MESH=IG_PickupViewMesh STRENGTH=0.1
#EXEC MESH SEQUENCE MESH=IG_PickupViewMesh SEQ=All STARTFRAME=0 NUMFRAMES=1
#EXEC MESH SEQUENCE MESH=IG_PickupViewMesh SEQ=Still STARTFRAME=0 NUMFRAMES=1
#EXEC MESHMAP SCALE MESHMAP=IG_PickupViewMesh X=0.04 Y=0.04 Z=0.08
#EXEC MESHMAP SETTEXTURE MESHMAP=IG_PickupViewMesh NUM=1 TEXTURE=IG_WeaponSkin
#EXEC MESHMAP SETTEXTURE MESHMAP=IG_PickupViewMesh NUM=2 TEXTURE=Damagewet

// ThirdPersonMesh
#EXEC MESH IMPORT MESH=IG_ThirdPersonMesh ANIVFILE=Models\IG_PickupViewMesh_a.3d DATAFILE=Models\IG_PickupViewMesh_d.3d
#EXEC MESH ORIGIN MESH=IG_ThirdPersonMesh X=-50 Y=-50 Z=0 PITCH=20 YAW=64
#EXEC MESH LODPARAMS MESH=IG_ThirdPersonMesh STRENGTH=0.1
#EXEC MESH SEQUENCE MESH=IG_ThirdPersonMesh SEQ=All STARTFRAME=0 NUMFRAMES=1
#EXEC MESH SEQUENCE MESH=IG_ThirdPersonMesh SEQ=Still STARTFRAME=0 NUMFRAMES=1
#EXEC MESHMAP SCALE MESHMAP=IG_ThirdPersonMesh X=0.03 Y=0.03 Z=0.06
#EXEC MESHMAP SETTEXTURE MESHMAP=IG_ThirdPersonMesh NUM=1 TEXTURE=IG_WeaponSkin
#EXEC MESHMAP SETTEXTURE MESHMAP=IG_ThirdPersonMesh NUM=2 TEXTURE=Damagewet

// PlayerViewMesh
#EXEC MESH IMPORT MESH=IG_PlayerViewMesh ANIVFILE=Models\IG_PlayerViewMesh_a.3d DATAFILE=Models\IG_PlayerViewMesh_d.3d
#EXEC MESH ORIGIN MESH=IG_PlayerViewMesh X=0 Y=0 Z=0 PITCH=16 YAW=70 ROLL=13
#EXEC MESH LODPARAMS MESH=IG_PlayerViewMesh STRENGTH=0.1
#EXEC MESH SEQUENCE MESH=IG_PlayerViewMesh SEQ=All STARTFRAME=0 NUMFRAMES=50
#EXEC MESH SEQUENCE MESH=IG_PlayerViewMesh SEQ=Still STARTFRAME=49 NUMFRAMES=1
#EXEC MESH SEQUENCE MESH=IG_PlayerViewMesh SEQ=Down STARTFRAME=1 NUMFRAMES=9
#EXEC MESH SEQUENCE MESH=IG_PlayerViewMesh SEQ=Fire STARTFRAME=10 NUMFRAMES=21
#EXEC MESH SEQUENCE MESH=IG_PlayerViewMesh SEQ=Select STARTFRAME=41 NUMFRAMES=9
#EXEC MESHMAP SCALE MESHMAP=IG_PlayerViewMesh X=0.01 Y=0.01 Z=0.02
#EXEC MESHMAP SETTEXTURE MESHMAP=IG_PlayerViewMesh NUM=0 TEXTURE=Automa1
#EXEC MESHMAP SETTEXTURE MESHMAP=IG_PlayerViewMesh NUM=1 TEXTURE=IG_WeaponSkin
#EXEC MESHMAP SETTEXTURE MESHMAP=IG_PlayerViewMesh NUM=2 TEXTURE=Damagewet

#EXEC TEXTURE IMPORT NAME=IG_StatusIcon FILE=Textures\IG_StatusIcon.pcx MIPS=OFF FLAGS=2

#EXEC AUDIO IMPORT NAME=IG_PickupSound FILE=Sounds\IG_PickupSound.wav
#EXEC AUDIO IMPORT NAME=IG_SelectSound FILE=Sounds\IG_SelectSound.wav
#EXEC AUDIO IMPORT NAME=IG_FireSound FILE=Sounds\IG_FireSound.wav
#EXEC AUDIO IMPORT NAME=IG_AltFireSound FILE=Sounds\IG_AltFireSound.wav

var int AltFireAmmo;

var IG_Handler Handler;

replication
{
	reliable if ( (Role == ROLE_Authority) && bNetOwner )
		Handler;
}

simulated function PostRender(canvas C)
{
	local int XOffset, YOffset;

	if ( (Handler == None) || (Handler.ImplantPawn == None) || (PlayerPawn(Owner) == None) || (PlayerPawn(Owner).myHUD == None) )
	return;

	XOffset = C.ClipX-128;

	if ( PlayerPawn(Owner).myHUD.HudMode == 5 )
	YOffset = C.ClipY-46;
	else
	YOffset = C.ClipY-110;

	C.CurX = XOffset;
	C.CurY = YOffset;

	C.DrawIcon(Texture'IG_StatusIcon',1.0);

	C.DrawColor.G = 128;
	C.DrawColor.B = 0;

	C.Font = Font'WhiteFont';

	XOffset += 5;
	YOffset += 4;

	C.CurX = XOffset;
	C.CurY = YOffset;

	C.DrawText(Handler.PawnName);

	YOffset += 14;

	C.CurX = XOffset;
	C.CurY = YOffset;

	C.DrawText("health:"@Handler.ImplantPawn.Health);

	YOffset += 14;

	C.CurX = XOffset;
	C.CurY = YOffset;

	C.DrawText("duration:"@Max(Handler.Duration+1,1));

	C.DrawColor.R = 255;
	C.DrawColor.G = 255;
	C.DrawColor.B = 255;
}

function OwnerJumped()
{
	if ( Handler != None )
	Handler.ImplantJump();
	else
	Super.OwnerJumped();
}

function PlaySelect()
{
	PlayAnim('Select',0.6);

	Owner.PlaySound(SelectSound,SLOT_Misc,Pawn(Owner).SoundDampening);
}

function PlayFiring()
{
	PlayAnim('Fire',1.5);

	Owner.PlaySound(FireSound,SLOT_None,2.0*Pawn(Owner).SoundDampening);
}

function PlayAltFiring()
{
	PlayAnim('Fire',1.5);

	Owner.PlaySound(AltFireSound,SLOT_None,2.0*Pawn(Owner).SoundDampening);
}

function Fire(float Value)
{
	if ( Handler != None )
	{
		Handler.ImplantFire();

		GotoState('ImplantFire');

		return;
	}

	if ( !AmmoType.UseAmmo(1) )
	return;

	GotoState('NormalFire');

	if ( PlayerPawn(Owner) != None )
	PlayerPawn(Owner).ShakeView(ShakeTime,0.5*ShakeMag,ShakeVert);

	Pawn(Owner).PlayRecoil(FiringSpeed);

	bPointing = True;

	PlayFiring();

	ProjectileFire(ProjectileClass,ProjectileSpeed,bWarnTarget);

	if ( Owner.bHidden )
	CheckVisibility();
}

function AltFire(float Value)
{
	if ( Handler != None )
	{
		GotoState('Release');
		return;
	}

	if ( (AmmoType.AmmoAmount > 0) && (AmmoType.AmmoAmount < AltFireAmmo) )
	{
		Global.Fire(Value);
		return;
	}

	if ( !AmmoType.UseAmmo(AltFireAmmo) )
	return;

	GotoState('AltFiring');

	if ( PlayerPawn(Owner) != None )
	PlayerPawn(Owner).ShakeView(ShakeTime,2*ShakeMag,ShakeVert);

	Pawn(Owner).PlayRecoil(FiringSpeed);

	bPointing = True;

	PlayAltFiring();

	ProjectileFire(AltProjectileClass,AltProjectileSpeed,bAltWarnTarget);

	if ( Owner.bHidden )
	CheckVisibility();
}

state NormalFire
{

Begin:
	FinishAnim();
	PlayAnim('Still',1.0,0.2);
	FinishAnim();
	Finish();
}

state AltFiring
{

Begin:
	FinishAnim();
	PlayAnim('Still',1.0,0.6);
	FinishAnim();
	Finish();
}

state ImplantFire
{
	ignores Fire, AltFire;

Begin:
	Sleep(0.01);
	GotoState('Idle');
}

state Release
{
	ignores Fire, AltFire;

Begin:
	if ( Handler != None )
	Handler.Destroy();
	Sleep(0.5);
	GotoState('Idle');
}

state Idle
{
	function AnimEnd()
	{}

	function bool FindProjectile()
	{
		local IG_ProjectileDart Dart;

		ForEach AllActors( class'IG_ProjectileDart', Dart )
		if ( Dart.Instigator == Owner )
		return True;

		return False;
	}

	function Timer()
	{
		if ( FindProjectile() )
		SetTimer(1.0,False);
		else if ( Handler == None )
		Pawn(Owner).SwitchToBestWeapon();
	}

Begin:
	bPointing = False;
	if ( Handler != None )
	Goto('Handler');
	FinishAnim();
	PlayAnim('Still',1.0,0.05);
	FinishAnim();
	if ( AmmoType.AmmoAmount < 1 )
	{
		if ( FindProjectile() )
		SetTimer(1.0,False);
		else
		Pawn(Owner).SwitchToBestWeapon();
	}

Handler:
	if ( Pawn(Owner).bFire != 0 )
	Fire(0);
	else if ( Pawn(Owner).bAltFire != 0 )
	AltFire(0);
}

state Active
{
	function BeginState()
	{
		Super.BeginState();

		SwapInventory();
	}

	function SwapInventory()
	{
		local Inventory Inv;

		if ( Owner.Inventory == Self )
		return;

		for ( Inv = Owner.Inventory; Inv != None; Inv = Inv.Inventory )
		if ( Inv.Inventory == Self )
		{
			Inv.Inventory = Self.Inventory;

			Inventory = Owner.Inventory;

			Owner.Inventory = Self;

			break;
		}
	}
}

simulated function PreBeginPlay()
{
	Super.PreBeginPlay();

	if ( (Int(Level.EngineVersion) < 226) && (Level.NetMode != NM_DedicatedServer) )
	MultiSkins[2] = Texture'UDamageFX';
}

defaultproperties
{
     AltFireAmmo=2
     ProjectileClass=Class'IG_ProjectileDart'
     AltProjectileClass=Class'IG_ProjectileBlast'
     FireOffset=(X=8.000000,Y=-5.000000,Z=-4.000000)
     AmmoName=Class'ImplantAmmo'
     PickupAmmoCount=10
     FiringSpeed=1.500000
     ShakeMag=200.000000
     ShakeVert=4.000000
     AIRating=0.000000
     PickupSound=Sound'IG_PickupSound'
     SelectSound=Sound'IG_SelectSound'
     FireSound=Sound'IG_FireSound'
     AltFireSound=Sound'IG_AltFireSound'
     DeathMessage="%o got a headache by %k's %w."
     InventoryGroup=2
     PickupMessage="You picked up the ImplantGun."
     ItemName="ImplantGun"
     PlayerViewScale=0.900000
     PlayerViewOffset=(X=8.000000,Y=-6.000000,Z=-4.000000)
     PlayerViewMesh=Mesh'IG_PlayerViewMesh'
     PickupViewMesh=Mesh'IG_PickupViewMesh'
     ThirdPersonMesh=Mesh'IG_ThirdPersonMesh'
     ThirdPersonScale=0.800000
     Mesh=Mesh'IG_PickupViewMesh'
     bNoSmooth=False
     CollisionRadius=14.000000
     CollisionHeight=20.000000
     Mass=10.000000
}
